// ARMSWDDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "ARMSWD.h"
#include "ARMSWDDlg.h"
#include "stdio.h"
//#include "process.h"
#include "daten.h"
#include "onfigDlg.h"
#include <fstream.h>
#include <time.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include "HEX_Func.h"

#include "FTD2XX.h"
#include "USB.h"
#include "RS232.h"
#include <stdio.h>
#include <io.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


HANDLE RS_Handle;		// COM-Schnittstelle;
DCB RS_DCB;				// COM-Schnittstelle;
ULONG ulSAnzahl;
ULONG ulRAnzahl;

FILE *logfile;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_strAbEdit;
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_strAbEdit = _T("");
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_ABOUT_ED, m_strAbEdit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CARMSWDDlg Dialogfeld

CARMSWDDlg::CARMSWDDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CARMSWDDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CARMSWDDlg)
	m_strEFile = _T("");
	m_uiPageAnzahl = 1;
	m_sStatusCRC = _T("");
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CARMSWDDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CARMSWDDlg)
	DDX_Control(pDX, IDC_P_DOWNLOAD, m_ctlPDownload);
	DDX_Control(pDX, IDC_L_PPROGRESS, m_ctlLProgress);
	DDX_Text(pDX, IDC_E_FILE, m_strEFile);
	DDX_Text(pDX, IDC_ED_STATUS_CRC, m_sStatusCRC);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CARMSWDDlg, CDialog)
	//{{AFX_MSG_MAP(CARMSWDDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_B_FILE, OnBFile)
	ON_BN_CLICKED(IDC_B_CONFIG, OnBConfig)
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_FLASH, OnFlash)
	ON_BN_CLICKED(IDC_RUN, OnRun)
	ON_WM_HELPINFO()
	ON_BN_CLICKED(IDC_TEST, OnTest)
	ON_BN_CLICKED(IDC_B_CMD_DL, OnBCmdDl)
	ON_BN_CLICKED(IDC_B_SECWRITEOK, OnBSecwriteok)
	ON_BN_CLICKED(IDC_B_STATUS, OnBStatus)
	ON_BN_CLICKED(IDC_START_LIN, OnStartLin)
	ON_BN_CLICKED(IDC_LIN_FLASH, OnLinFlash)
	ON_BN_CLICKED(IDC_B_WRONG_FRAME, OnBWrongFrame)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CARMSWDDlg Nachrichten-Handler

BOOL CARMSWDDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

	// Fenster nur mit Men-Funktion beendbar machen
	//pSysMenu->EnableMenuItem(SC_CLOSE , MF_BYCOMMAND | MF_DISABLED);

//	GetDlgItem(IDC_FLASH)->EnableWindow(FALSE);
//	GetDlgItem(IDC_RUN)->EnableWindow(FALSE);

	SetStartButtons();

	// defaut ini
	AppData.strIni="proj.ini";
	AppData.str_Message = "";			// No message
	AppData.strUSB_ParserError = "";	// No parser error
	AppData.m_USBOpen = FALSE;			// USB not open
	AppData.m_PortCom = FALSE;			// COM not open
	AppData.m_Online = FALSE;			// Communication offline
	AppData.m_PortCom = 0;				// no port selected
	AppData.m_strCommuSpeed = "none";   // no Speed selected
	AppData.m_strComSpeed = "9600 Baud";
	AppData.m_strUSBSpeed = " unknown ";

	AppData.m_strComSet	= "9600,n,8,1";	// Settings for COM
	AppData.m_Answer = 0;
	AppData.m_Setup = FALSE;			// no setup was done
	AppData.m_IniFile = FALSE;			// no IniFile
	AppData.m_BlockSize = 15;			// 16 bytes per block

	AppData.m_CPU = 0;					// 702x = 0, 703x = 1
	AppData.m_LIN_CPU = 0;				// 7030
	AppData.m_SW_PID = 0xF0;			// 0x30 only ID
	AppData.m_AW_PID = 0xB1;			// 0x31	only ID
	AppData.m_DW_PID = 0x32;			// 0x32	only ID
	AppData.m_SR_PID = 0x73;			// 0x33	only ID

	AppData.iMemSize = 1;				// Dummy
	AppData.m_AdrOffset = 0;			// Offset for Adress (get by the 02 record type in HEX-File)

	//Help
	AppData.m_strEcBrowser="IEXPLORE.EXE";
	AppData.m_strEcHelpp="c:\\adi";




//	HWND hAppWindow;

//	hAppWindow = GetDlgItem(hwndDlg, IDD_ARMSWD_DIALOG); 

	

	//pWnd = GetDlgItem(IDD_ARMSWD_DIALOG); (LPSTR)

	if(AppData.m_CPU == 1)
		(AfxGetMainWnd( ))->SetWindowText("LINWSD");
	else
		(AfxGetMainWnd( ))->SetWindowText("I2CWSD"); 


	// JH read inifile 
	// get the path
	HINSTANCE hInstance;
	char pcPath[1024];

	hInstance=AfxGetInstanceHandle();
	GetModuleFileName(hInstance, pcPath, 1023);
	AppData.strAppPath=pcPath;
	AppData.strAppPath=AppData.strAppPath.Left(AppData.strAppPath.ReverseFind('\\')+1);
	AppData.strIni=AppData.strAppPath+"armwsd"+".ini";

	AppData.ReadIni();
	m_strEFile=AppData.strDFile;


	UINT m_ReportBar[7] = {ID_STATUS1, ID_STATUS2, ID_STATUS3, ID_STATUS4, ID_STATUS5,ID_STATUS6,ID_STATUS7};
	ReportBar.Create(this,WS_CHILD | WS_VISIBLE | CBRS_BOTTOM,AFX_IDW_STATUS_BAR );
	ReportBar.SetIndicators(m_ReportBar,7);
	ReportBar.SetPaneInfo(0,ID_STATUS1,SBPS_NORMAL,80);
	ReportBar.SetPaneInfo(1,ID_STATUS2,SBPS_NORMAL,60);
	ReportBar.SetPaneInfo(2,ID_STATUS3,SBPS_NORMAL,50);
	ReportBar.SetPaneInfo(3,ID_STATUS4,SBPS_NORMAL,115);
	ReportBar.SetPaneInfo(4,ID_STATUS5,SBPS_NORMAL,80);
	ReportBar.SetPaneInfo(5,ID_STATUS6,SBPS_NORMAL,100);
	ReportBar.SetPaneInfo(6,ID_STATUS7,SBPS_STRETCH,80);


	UpdateSBar();

	
	CString strRunBut = "Restart";

	if(AppData.m_CPU == 1)
	{
		
		GetDlgItem(IDC_ED_STATUS_CRC)->EnableWindow(TRUE);
		SetDlgItemText(IDC_RUN,"Reset");
		AppData.m_masserase	= FALSE;
		AppData.m_program	= TRUE;
		AppData.m_verify	= TRUE;

		if(AppData.m_iCRC == 0)
			m_sStatusCRC = "CRC-Calculation from imported HEX File";

		if(AppData.m_iCRC == 1)
			m_sStatusCRC = "CRC for Code Development";

		if(AppData.m_iCRC == 2)
			m_sStatusCRC = "CRC from imported HEX File";
			
	}
	else
	{
		SetDlgItemText(IDC_RUN,"Run");
		GetDlgItem(IDC_ED_STATUS_CRC)->EnableWindow(FALSE);
	}


	if(!AppData.m_IniFile)
	{
		//MessageBox("No configuration, please click Config"); 
		m_ctlLProgress.AddString("   No configuration, please click Configure");
		m_ctlLProgress.AddString("   No HEX-File, please click Browse.. to select file");
	}
	else
	{
		if(AppData.strDFile.GetLength() == 0)
		{
			m_ctlLProgress.AddString("   No HEX-File, please click Browse.. to select file");
		}
		else
		{
			m_ctlLProgress.AddString("   Please connect test board to USB");
			m_ctlLProgress.AddString("   Press Download and pulse Reset on Hardware before click Start");
		}
	}

	
/*	if ((RS_Handle=CreateFile("COM2",GENERIC_READ|GENERIC_WRITE,
	   FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL))==
	   INVALID_HANDLE_VALUE)
		MessageBox("COM2 nicht verfgbar","",MB_ICONEXCLAMATION);

	FillMemory(&RS_DCB, sizeof(RS_DCB),0);
	RS_DCB.DCBlength = sizeof(RS_DCB);
	//BuildCommDCB("19200,N,8,1", &RS_DCB);

	RS_DCB.BaudRate = CBR_19200;     // set the baud rate
	RS_DCB.ByteSize = 8;             // data size, xmit, and rcv
	RS_DCB.Parity = NOPARITY;        // no parity bit
	RS_DCB.StopBits = ONESTOPBIT;    // one stop bit


	SetCommState(RS_Handle,&RS_DCB);
*/

	UpdateData(FALSE);

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CARMSWDDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CARMSWDDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CARMSWDDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CARMSWDDlg::OnOK() 
{
	//if(!USB_Close())
		//MessageBox(AppData.str_Message,AppData.strUSB_ParserError,MB_OK);
	USB_Close();
	//if(AppData.m_bFileOpen)

//	RS232_Close();

	CDialog::OnOK();
	
}

void CARMSWDDlg::OnCancel() 
{
	//if(!USB_Close())
		//MessageBox(AppData.str_Message,AppData.strUSB_ParserError,MB_OK);
	USB_Close();
//	RS232_Close();


	CDialog::OnCancel();

}

void CARMSWDDlg::OnBFile() 
{
/*		CString	strFilePath; 
	CString	strFileName; 
	CString	strFileExtension;
	CString	strFileTitle;
	CString	m_strEFile;
*/


	static char Filter[] = "*.hex |*.hex|All Files|*.*||";
	CFileDialog	FileDialog(TRUE,NULL,NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,Filter);
	//CString	str1;
	//int		i1;

	FileDialog.m_ofn.lpstrTitle = "Select File";
	/*i1 = AppData.strDFile.ReverseFind('\\')+1;
	str1 = AppData.strDFile.Right(AppData.strDFile.GetLength()-i1);
	strcpy(FileDialog.m_ofn.lpstrFile,str1);
	str1 = AppData.strDFile.Left(i1);
	FileDialog.m_ofn.lpstrInitialDir = str1;
	*/
	if(FileDialog.DoModal()==IDOK)
	{
		AppData.strFilePath = FileDialog.GetPathName();
		AppData.strFileName = FileDialog.GetFileName();
		AppData.strFileExtension = FileDialog.GetFileExt();
		AppData.strFileTitle = FileDialog.GetFileTitle();
		AppData.strDFile = AppData.strFilePath;
		m_strEFile = AppData.strFilePath;
		
		//JH inifile
		AppData.WriteIni();

		
		m_ctlLProgress.ResetContent();
		m_ctlLProgress.AddString("   Please connect test board to USB");
		m_ctlLProgress.AddString("   Press Download and pulse Reset on Hardware before click Start");
		
	}

	UpdateData(FALSE);	
}

void CARMSWDDlg::OnBConfig() 
{
	CString help;
	ConfigDlg mCDlg;
	
	BOOL	bIniFile,bHEX;

	bIniFile = AppData.m_IniFile;

	if(AppData.strDFile.GetLength() == 0)
		bHEX = FALSE;
	else
		bHEX = TRUE;


	if(mCDlg.DoModal()==IDOK)
	{
	}

	m_ctlLProgress.ResetContent();
	UpdateWindow();

	if(bIniFile || bHEX)
	{
		m_ctlLProgress.AddString("   Please connect test board to USB");
		m_ctlLProgress.AddString("   Press Download and pulse Reset on Hardware before click Start");	
	}
	else
	{
		if(!bHEX)
		m_ctlLProgress.AddString("   No HEX-File, please click Browse.. to select file");

	}

	if(AppData.m_CPU == 1)
	{
		if(AppData.m_iCRC == 0)
			m_sStatusCRC = "CRC-Calculation from imported HEX File";

		if(AppData.m_iCRC == 1)
			m_sStatusCRC = "CRC for Code Development";

		if(AppData.m_iCRC == 2)
			m_sStatusCRC = "CRC from imported HEX File";
			
	}

	UpdateSBar();

	UpdateData(FALSE);

}

void CARMSWDDlg::OnStart() 
{
	CString str;
	int		i1;
	BOOL	bSetup;
	BOOL	bCommu = TRUE;

	ButtonsOff();									// to prevent Useraction

	if(AppData.m_AutoClear)
	{
		m_ctlLProgress.ResetContent();
		UpdateWindow();
	}
	
	//m_ctlLProgress.AddString("");
	//m_ctlLProgress.AddString("Press Download and pulse Reset on Hardware");	

	UpdateData(FALSE);

	switch (AppData.m_PortCom)
	{
		case 1: bSetup = USB_Setup();
				break;
//		case 2:	bSetup = RS232_Setup();
//				break;
		default:
				bCommu = FALSE;
				break;
	}

	if(!bCommu)
	{
		MessageBox("No Communication Port");
		ButtonsOn();
		return;
	}


	if(bSetup)
	{
		str = "Connected to " + AppData.str_Message;
		
		if((i1 = m_ctlLProgress.AddString(str))>3)	
				i1 -= 3;
		m_ctlLProgress.SetTopIndex(i1);

		AppData.m_Online = TRUE;

		AppData.m_PortCom = 1;

		UpdateSBar();

	}
	else
	{
		str = "   Error in Communication: " + AppData.str_Message;
		if((i1 = m_ctlLProgress.AddString(str))>3)	
				i1 -= 3;
		m_ctlLProgress.SetTopIndex(i1);
		//ShowErrors(str);
		SetStartButtons();
	}

	ButtonsOn();									// allow Useraction

//	UpdateData(FALSE);
	
}

void CARMSWDDlg::OnFlash() 
{
	CString str;

//	m_ctlLProgress.AddString("Do Flash");

	ButtonsOff();									// to prevent Useraction

	if(AppData.m_CPU == 0)
	{
		if(!DoFlash_I2C())
		{
//		str = "Error in Data Sequence !";			// + AppData.strUSB_Message;
//		ShowErrors(str);
		}
		else
		{
			str = "Processing ok";
	//	m_ctlLProgress.AddString(str);
		}
	}
	else
	{
		if(!DoFlash_LIN())
		{
//		str = "Error in Data Sequence !";			// + AppData.strUSB_Message;
//		ShowErrors(str);
		}
		else
		{
			str = "Processing ok";
	//	m_ctlLProgress.AddString(str);
		}
	}

//	m_ctlLProgress.AddString(" ");
	ButtonsOn();									// allow Useraction
}

void CARMSWDDlg::OnRun() 
{
	CString str;
	int i1;
	
	ButtonsOff();

	if(!USB_Run_CMD())
	{
		str = "   Error in Command Sequence !"; // + AppData.strUSB_Message;
		//ShowErrors(str);

		m_ctlLProgress.AddString(str);
		m_ctlLProgress.AddString("   Please connect test board to USB");
		if((i1 = m_ctlLProgress.AddString("   Press Download and pulse Reset on Hardware before click Start"))>3)	
				i1 -= 3;
		m_ctlLProgress.SetTopIndex(i1);
		//AppData.str_Message
	}
	else
	{
		GetDlgItem(IDC_FLASH)->EnableWindow(FALSE);
		GetDlgItem(IDC_RUN)->EnableWindow(FALSE);
		m_ctlLProgress.AddString(AppData.str_Message);

		m_ctlLProgress.AddString(" ");
		m_ctlLProgress.AddString("   For new Download");
		if((i1 = m_ctlLProgress.AddString("   Press Download and pulse Reset on Hardware before click Start"))>3)	
				i1 -= 3;
		m_ctlLProgress.SetTopIndex(i1);
	}

	ButtonsOn();
	
}

void CARMSWDDlg::ShowErrors(CString &str)
{
	CString strMes;

	m_ctlLProgress.AddString(str);
	strMes = "   Failure: " + AppData.strUSB_ParserError;
	m_ctlLProgress.AddString(strMes);

	m_ctlLProgress.AddString(" ");
	m_ctlLProgress.AddString("   Please connect test board to USB");
	m_ctlLProgress.AddString("   Press Download and pulse Reset on Hardware before click Start");
}

void CARMSWDDlg::SetStartButtons()
{
	GetDlgItem(IDC_FLASH)->EnableWindow(FALSE);
	GetDlgItem(IDC_RUN)->EnableWindow(FALSE);
	GetDlgItem(IDC_B_CONFIG)->EnableWindow(TRUE);
	GetDlgItem(IDC_START)->EnableWindow(TRUE);
}

void CARMSWDDlg::ButtonsOn()
{
	GetDlgItem(IDC_FLASH)->EnableWindow(TRUE);
	GetDlgItem(IDC_RUN)->EnableWindow(TRUE);
	GetDlgItem(IDC_B_CONFIG)->EnableWindow(TRUE);
	GetDlgItem(IDC_START)->EnableWindow(TRUE);
	GetDlgItem(IDC_B_FILE)->EnableWindow(TRUE);
}

void CARMSWDDlg::ButtonsOff()
{
	GetDlgItem(IDC_FLASH)->EnableWindow(FALSE);
	GetDlgItem(IDC_RUN)->EnableWindow(FALSE);
	GetDlgItem(IDC_B_CONFIG)->EnableWindow(FALSE);
	GetDlgItem(IDC_START)->EnableWindow(FALSE);
	GetDlgItem(IDC_B_FILE)->EnableWindow(FALSE);
}

void CARMSWDDlg::UpdateSBar()
{
	CString str;
	
	if(AppData.m_CPU == 0)
	{
		if(AppData.m_masserase)
			ReportBar.SetPaneText(0," MassErase " ,TRUE );
		else
			ReportBar.SetPaneText(0,"  no MassErase" ,TRUE );
	}
	else
		ReportBar.SetPaneText(0," " ,TRUE );

	if(AppData.m_program)
		ReportBar.SetPaneText(1," Program " ,TRUE );
	else
		ReportBar.SetPaneText(1," no Program" ,TRUE );

	if(AppData.m_verify)
		ReportBar.SetPaneText(2," Verify ",TRUE );
	else
		ReportBar.SetPaneText(2," no Verify ",TRUE );

	switch (AppData.m_PortCom)
		{
		case 0:
				ReportBar.SetPaneText(3," Communication: none" ,TRUE );
				break;
		
		case 1:
				ReportBar.SetPaneText(3," Communication: USB" ,TRUE );
				break;
			
		case 2:
			
				ReportBar.SetPaneText(3," Communication: COM" ,TRUE );
				break;
			
		default:
			break;
		}


	if(AppData.m_Online)
		ReportBar.SetPaneText(4," Mode: online" ,TRUE );
	else
		ReportBar.SetPaneText(4," Mode: offline" ,TRUE );


	str = " Speed: ";

	switch (AppData.m_PortCom)
	{
		case 0:
				str += "none";
				break;
		
		case 1:
				str += AppData.m_strUSBSpeed;
				break;
			
		case 2:
			
				str += AppData.m_strComSpeed;
				break;
			
		default:
			break;
	}

	ReportBar.SetPaneText(5,str,TRUE );

	switch (AppData.m_CPU)
	{
		case 0:
				ReportBar.SetPaneText(6," CPU: 702x" ,TRUE );
				break;
		
		case 1:
				//str = " CPU:" + AppData.str_Message;
				//ReportBar.SetPaneText(6,str ,TRUE );
				ReportBar.SetPaneText(6,"CPU: 7032" ,TRUE );
				break;	
		default:
			break;
	}

	

	RepositionBars(AFX_IDW_STATUS_BAR,AFX_IDW_STATUS_BAR,0,reposDefault,NULL,NULL);
}


/********************************************************************************************
*
*  Import HEX Data
*
*	Function imports HEX data in Intel HEX format an stored data in an array with 21 columns.
*	The array contains the following subset from the HEX-file:
*	
*   [0]:	programm data flag (0x0 no programming data, 0x1 programming data)
*	[1]:	data length from HEX-file
*	[2..4]:	24 bit address
*	[5..20]:HEX data
*
*	The CRC of the HEX-File is tested, if failed the function abort the import
*
*	AppData.strDFile :		Filepath for HEX-file
*	AppData.m_HexArray:		unsigned char array [xxxx][21] 
*	AppData.m_HexRows:		unsigned int for maximum rows imported
*	AppData.m_HexBytes:		unsigned int for maximum data bytes imported
*	AppData.m_EndAddress:	unsigned long for last address of imported data
*	AppData.m_ErasePages:	unsigned int for amount of pages to erase
*	AppData.m_CPU:			BYTE to identify ADuC (702x and 703x)
*
********************************************************************************************/
void CARMSWDDlg::ImportHexData()
{	
	unsigned int	usRow = 0;					// Counter for rows
	unsigned char	pcHexData[32];
	char			pcHexTxt[520];
	unsigned long	lProgAddr, lOverlapAddr, lLastAddr = 0;
	unsigned long	lStartAddr,lEndAddr;
	unsigned char	iDataLen,iAddrRest;
	unsigned int	iMaxData = 0;
	unsigned char	iPageCounter = 0;

	unsigned char   i1,i2;

	CString str,str1;

	for(i1=0;i1<188;i1++)
		AppData.m_PageArray[i1] = 0;					// clear PageArray

	ifstream ihexFile(AppData.strDFile,ios::in );

	AppData.m_HexBytes = 0;						// no data to program

	if(!ihexFile)	
	{
		AfxMessageBox("File Open Error");		//  read file error 
		return;									//	abort
	}
	else
	{
		ihexFile >> pcHexTxt;					//First line of .hex file

		
		while(strncmp(pcHexTxt,":00000001FF",11)!=0 ) 	//While not end of .hex file.
		{	
			iDataLen=0;
			
			ImportHexLn(pcHexTxt,&lProgAddr,&iDataLen,pcHexData);

			if(iDataLen>0)
			{
				AppData.m_HexArray[usRow][0] = 0x01;	// dataline
				AppData.m_HexArray[usRow][1] = (unsigned char)(iDataLen);
				AppData.m_HexArray[usRow][2] = (unsigned char)(lProgAddr/65536);
				AppData.m_HexArray[usRow][3] = (unsigned char)(lProgAddr/256);
				AppData.m_HexArray[usRow][4] = (unsigned char)(lProgAddr%256);


				lStartAddr = lProgAddr;
				lEndAddr = lProgAddr + (unsigned long)iDataLen;

				iPageCounter = (unsigned char)(lStartAddr/512);		// Page of start
				AppData.m_PageArray[iPageCounter] = 1;
				iPageCounter = (unsigned char)(lEndAddr/512);		// Page of end
				AppData.m_PageArray[iPageCounter] = 1;

				if(AppData.m_CPU == 1)					// 703x
				{

					lOverlapAddr = lProgAddr + (unsigned long)(iDataLen-1);	// new End Address

					if((lProgAddr < 0x90000) && (lOverlapAddr > 0x8FFFF))	
					{
						AfxMessageBox("Correct HEX-File for Blockmapping");

						iAddrRest = (unsigned char)(0x10000 - lProgAddr);

						// Fill Array up to 0xFFFF; 
						for(i1=0;i1<iAddrRest;i1++)
						{
							AppData.m_HexArray[usRow][i1+5] = pcHexData[i1];
							iMaxData++;
							if(lLastAddr<(lProgAddr+(unsigned long)(iDataLen-1)))
							   lLastAddr = lOverlapAddr;

						}
						usRow++;

						iAddrRest = iDataLen - iAddrRest;		// rest of bytes for new frame

						// Create a new startaddress
						AppData.m_HexArray[usRow][0] = 0x01;	// dataline
						AppData.m_HexArray[usRow][1] = iAddrRest;
						AppData.m_HexArray[usRow][2] = 0x01;//(unsigned char)(lProgAddr/65536);
						AppData.m_HexArray[usRow][3] = 0x00;//(unsigned char)(lProgAddr/256);
						AppData.m_HexArray[usRow][4] = 0x00;//(unsigned char)(lProgAddr%256);

						for(i2=0;i2<iAddrRest;i2++)
						{
							i1++;
							AppData.m_HexArray[usRow][i2+5] = pcHexData[i1];
							iMaxData++;
							if(lLastAddr<(lProgAddr+(unsigned long)(iDataLen-1)))
							   lLastAddr = lOverlapAddr;

						}
						usRow++;
					
					}
					else
					{										// 702x

						for(unsigned char i=0;i<iDataLen;i++)
						{
							AppData.m_HexArray[usRow][i+5] = pcHexData[i];
							iMaxData++;
							if(lLastAddr<(lProgAddr+(unsigned long)(iDataLen-1)))
							   lLastAddr = lOverlapAddr;

						}
						usRow++;
					}
				}
				else
				{

					for(unsigned char i=0;i<iDataLen;i++)
					{
						AppData.m_HexArray[usRow][i+5] = pcHexData[i];
						iMaxData++;
						if(lLastAddr<(lProgAddr+(unsigned long)(iDataLen-1)))
						   lLastAddr = lProgAddr+(unsigned long)(iDataLen-1);
					}
					usRow++;
				}
				
			}
			else
			{
				AppData.m_HexArray[usRow][0] = 0x00;	// no dataline
				//m_ctlLProgress.AddString("No data");
			}

			ihexFile >> pcHexTxt;			// next line
			
		
		}

		AppData.m_EndAddress = lLastAddr;

		AppData.m_HexArray[usRow][0] = 0x00;	
		AppData.m_HexArray[usRow][1] = 0x00;
		AppData.m_HexArray[usRow][2] = 0x00;
		AppData.m_HexArray[usRow][3] = 0x00;
		AppData.m_HexArray[usRow][4] = 0x00;

		//str.Format("DataRows: %.4X", AppData.m_EndAddress);
		//m_ctlLProgress.AddString(str);

/*		str.Format("Dat: %.2X", AppData.m_HexArray[usRow-1][5]);
		for(int j=6;j<13;j++)
		{
			str1.Format(" %.2X",AppData.m_HexArray[usRow-1][j]);
			str += str1;
		}
		m_ctlLProgress.AddString(str);
*/		
		ihexFile.close();

		AppData.m_HexRows = usRow;
		AppData.m_HexBytes = iMaxData;


		// collect the amount of pages to erase
		iPageCounter = 0;
		for(i1=0;i1<184;i1++)
		{
			if(AppData.m_PageArray[i1] != 0)
				iPageCounter++;
		}

		AppData.m_ErasePages = iPageCounter;
		
		//str1.Format(" Pages to Erase: %d",iPageCounter);
		//m_ctlLProgress.AddString(str1);
	}


	switch (AppData.m_CPU)
	{
	case 0:
			if(AppData.m_EndAddress > 0xF7FF)  // no data in Kernel Space allowed	ADuC702x	
				AfxMessageBox("Last address in file exceeds addressrange \n please check file");
			break;
	case 1: 
			if((AppData.m_EndAddress > 0x8F7FF) && (AppData.m_LIN_CPU == 0))  // no data in Kernel Space allowed  ADuC7030
				AfxMessageBox("Last address in file exceeds addressrange \n please check file");
			
			if((AppData.m_EndAddress > 0x977FF) && (AppData.m_LIN_CPU == 1))  // no data in Kernel Space allowed  ADuC7032
				AfxMessageBox("Last address in file exceeds addressrange \n please check file");

			break;
	default:
			break;
	}


	
	
}

BOOL CARMSWDDlg::DoFlash_LIN() 
{
	CString			str, str1, dummy;

	DWORD			dwEnd,dwNow;
	int				iProcessPos, iProcessStep;
	double			dSec;

	BYTE			iChar = 0;
	BYTE			iCRC = 0;
	BYTE			iCRCs = 0;
	
	DWORD			dwToSend;
	unsigned int	i1,i2;
	unsigned short	CRC		= 0;
	unsigned int	b,br, iDataCount, iActRow;
	int				iSize;
	int				iErr = 0;
	const unsigned short MAX_MESSAGE = 100;
	unsigned char	pcPacket[256];
	BYTE			pcCommand[10];
	unsigned char   pcData[320];
	unsigned char	pcStatus[9];

	unsigned char	pcMassErase[11] = {0x06,0x00,0x45,0x00,0x00,0x00,0x08,0x00,0x00,0xFF,0x00}; // change byte 6 to 0x08, 06.07.02005 

//	char			pcHexTxt[520] ;
	unsigned long	lProgAddr,lProgAddrN,ulPage0CRC;
//	unsigned int	iDataLen;
	long			lPktNo = 1;
	unsigned char	ucTempPageCounter;
	unsigned char	usTempStatus;
	unsigned int	uiPageCRC,uiGetCRC;

	BOOL			bNoError = FALSE;		// ErrorFlag for single action (MassErase, Write, Verify)
	
	BOOL			bLocalCmd = FALSE;
	BOOL			bHEXInputOK = FALSE;

	int				i3,iFrameblocks, iFrameRest, iArrayData, iPacket;

	CFileStatus		status;

	if(CFile::GetStatus(AppData.strDFile,status))	
		iSize = status.m_size*16/45;


	ImportHexData();						// Import HEX
	ClearPageCS();							// sets 0x14 to 0xFFFFFFFF
	FillCRCArray();							// configure Page Array for CRC
	

	
	if(AppData.m_HexBytes != 0)
	{
		if(AppData.m_masserase==1)					
		{
			str1.Format("Mass Erasing ...");
			if((i1 = m_ctlLProgress.AddString(str1))>3)	
				i1 -= 3;
			m_ctlLProgress.SetTopIndex(i1);
			UpdateWindow();

			pcMassErase[1] = AppData.m_AW_PID;
			pcMassErase[10] = CRC_Enhanced(pcMassErase);
			
			switch (AppData.m_PortCom)
			{
				case 1: dwNow = GetTickCount();
						//m_ctlLProgress.AddString("Start");
						bLocalCmd = USB_Send_LIN(11, pcMassErase);
						//m_ctlLProgress.AddString("End");
						if(!bLocalCmd)
						{	
							//str = "   Error in Data Sequence !";	// + AppData.strUSB_Message;
							//ShowErrors(str);
							str1.Format("   Error from MassErase : %X",AppData.m_Answer);
							m_ctlLProgress.AddString(str1);
							break;
						}

						EraseBar();
						
						bLocalCmd = USB_Read_Status(pcStatus);
						dwEnd = GetTickCount();
					break;
				default:
					AfxMessageBox("No Communication Port");
					bLocalCmd = FALSE;	
					break;
			}

			dSec = (double)(dwEnd-dwNow);//1000;
			str1.Format("   Time to Erase: %.3f s",(dSec/1000));
			m_ctlLProgress.AddString(str1);

			if(!bLocalCmd)
			{
				str1.Format("   Error from MassErase : %X",AppData.m_Answer);
				m_ctlLProgress.AddString(str1);
				m_ctlPDownload.SetPos(0);
				return FALSE;
			}
			else
			{
				USB_Read_Status(pcStatus);

			//	str.Format("Read Status: ");

				CRC = AppData.m_SR_PID;						// because PID is not in frame, but CRC is Enhanced

				for(int i=0;i<8;i++)
				{
					CRC += pcStatus[i];
					if(CRC > 255)
						CRC -= 255;
					str1.Format("%.2X ",pcStatus[i]);
					str += str1;
				}

				iCRC = (BYTE)~CRC;							// should be value of CRC-Field

				iCRCs = ((BYTE)CRC) + pcStatus[8];			// should be 0xFF
				
				str1.Format(" CRC:%.2X ",pcStatus[8]);
				str += str1;

			//	AfxMessageBox(str);
				
				//m_ctlLProgress.AddString(str);

				m_ctlPDownload.SetPos(0);

				if((iCRC != pcStatus[8]) || (iCRCs != 0xFF)) 
				{
					str.Format("Error: CRC get: %.2X  need: %.2X  calculated: %.2X",pcStatus[8], iCRC,iCRCs);
					m_ctlLProgress.AddString(str);
					//AfxMessageBox(str);
					AppData.str_Message = " CRC Error";

					iErr=25;
					bNoError = FALSE;

				}
				else
				{
					iErr=1;
					bNoError = TRUE;

				}

				CRC = Check_Status_Byte(pcStatus[2], 0x08);
				
				if(CRC == 1)
				{
					if((i1 = m_ctlLProgress.AddString("Error during Erase"))>3)	
					i1 -= 3;
					m_ctlLProgress.SetTopIndex(i1);
				}

				if(CRC == 255)
				{
					if((i1 = m_ctlLProgress.AddString("Error in Frame"))>3)	
					i1 -= 3;
					m_ctlLProgress.SetTopIndex(i1);
				}
				
				
			}

		}


		if((AppData.m_program != 1) && (AppData.m_masserase == 1) && (AppData.m_verify != 1))	// only Mass Erase selected
		{
			m_ctlLProgress.AddString("Mass Erasing ok");
			return bNoError;
		}

		
		if(AppData.m_program==1)					// Program
		{
			
			if(AppData.m_LIN_CPU == 0)
			{
				if(AppData.m_EndAddress > 0x877FF) 
				{
					AfxMessageBox("Last address in file exceeds addressrange \n Download aborted.");
					//AfxMessageBox(str1);
					//bNoError = FALSE;
					return FALSE;
				}
			}

			if(AppData.m_LIN_CPU == 1)
			{
				if(AppData.m_EndAddress > 0x977FF) 
				{
					AfxMessageBox("Last address in file exceeds addressrange \n Download aborted.");
					//AfxMessageBox(str1);
					//bNoError = FALSE;
					return FALSE;
				}
			}


			
			m_ctlLProgress.AddString("Programm...");

			lPktNo = 1;
			
			if(AppData.m_masserase!=1)				// only erase if no mass erase was done
			{
				
				str1.Format("   Erasing %d pages of 512 bytes each.",AppData.m_ErasePages);

				if((i1 = m_ctlLProgress.AddString(str1))>3)	i1 -= 3;
				m_ctlLProgress.SetTopIndex(i1);

				m_ctlPDownload.SetRange(0,(int)AppData.m_ErasePages);	//Progress bar.
				iProcessStep = 1;
				iProcessPos = 0;
				m_ctlPDownload.SetPos(iProcessPos);
		
				dwNow = GetTickCount();								// Debug

				// get highest page
				i3 = 0;
				for(i1=0; i1<188;i1++)
				{
					if(AppData.m_PageArray[i1] != 0)
						i3 = i1;
				}
				i3++;

				//str1.Format("Highest Page: %d",(i3-1));
				//m_ctlLProgress.AddString(str1);


				//for(i1=0; i1<184; i1++)
				//for(i1=0; i1<5; )
				i1=0;
				i2=0;
				do
				{
					if(AppData.m_PageArray[i1] != 0)			// only if marked
					{		
						lProgAddr = 0x80000 + 512 * (unsigned long)i1;	// calculate address	
						
						pcCommand[0] = 0x06;
						pcCommand[1] = AppData.m_AW_PID;
						pcCommand[2] = 'E';                  
						pcCommand[3] = (unsigned char)(lProgAddr%256);
						pcCommand[4] = (unsigned char)((lProgAddr>>8) %256);                 
						pcCommand[5] = (unsigned char)((lProgAddr>>16)%256); 
						pcCommand[6] = (unsigned char)((lProgAddr>>24)%256);
						pcCommand[7] = 0x0;
							
						pcCommand[9] = 0xFF;
						pcCommand[10] = CRC_Enhanced(pcCommand);// calculate CRC

						ucTempPageCounter = 0;
						do
						{
							if(AppData.m_PageArray[i1] != 0)
							{
								ucTempPageCounter++;
								i1++;
							}
						}
						while((AppData.m_PageArray[i1] != 0) && ((i1*512+(unsigned int)(lProgAddr & 0x0FFFF))<65535)); 
						
						pcCommand[8] = ucTempPageCounter * 2;
						pcCommand[10] = CRC_Enhanced(pcCommand);// calculate CRC

						//str1.Format(" Pagestart: %.4X  PageCounter: %d i1: %d",lProgAddr,ucTempPageCounter,i1);
						//m_ctlLProgress.AddString(str1);

						iProcessPos += iProcessStep;
						m_ctlPDownload.SetPos(iProcessPos);

						switch (AppData.m_PortCom)
						{
							case 1: 
									bLocalCmd = USB_Send_LIN(11, pcCommand);
								break;
	//						case 2:	bLocalCmd = RS232_Send_Frame(10, pcPacket);
	//							break;
							default:
								AfxMessageBox("No Communication Port");
								bLocalCmd = FALSE;	
								break;
						}

						if(!bLocalCmd)
						{
							str = "   Error in Erase Sequence !"; // + AppData.strUSB_Message;
							ShowErrors(str);
							iErr=25;
							m_ctlPDownload.SetPos(0);
							return FALSE;
						}
						else
						{
							iErr=1;

							bLocalCmd = USB_Read_Status(pcStatus);

							if(!bLocalCmd)
							{
								str = "   Error in Status Sequence !"; // + AppData.strUSB_Message;
								ShowErrors(str);
								iErr=25;
								m_ctlPDownload.SetPos(0);
								return FALSE;
							}
							else
							{
								str1.Format(" Status:%.2X  %.2X %.2X  %.2X",
												pcStatus[0],pcStatus[1],pcStatus[2],pcStatus[3]);
								//m_ctlLProgress.AddString(str1);

								CRC = Check_Status_Byte(pcStatus[2], 0x08);
				
								if(CRC == 1)
								{
									if((i1 = m_ctlLProgress.AddString("Error during Erase"))>3)	
									i1 -= 3;
									m_ctlLProgress.SetTopIndex(i1);
								}

								if(CRC == 255)
								{
									if((i1 = m_ctlLProgress.AddString("Error in Frame"))>3)	
									i1 -= 3;
									m_ctlLProgress.SetTopIndex(i1);
								}
								
							}

							
						}
						//i2++;

					}
					else
					{
						i1++;
						//i2++;
						//m_ctlLProgress.AddString("No Page");
					}

				}
				while(i1<(unsigned int)i3);

				//str1.Format(" Pagestart: %.4X",lProgAddr);
				//m_ctlLProgress.AddString(str1);

				dwEnd = GetTickCount();
				dSec = (double)(dwEnd-dwNow);//1000;
				str1.Format("     Time to Erase: %.3f s",(dSec/1000));
				//m_ctlLProgress.AddString(str1);

				//iErr = 25;
			}	

		}


		if(AppData.m_program==1 && iErr<10)
//		if(iErr<10)
		{

			str1.Format("%s%d%s","   Programming ... ",AppData.m_HexBytes," bytes");

			if((i1 = m_ctlLProgress.AddString(str1))>3)	i1 -= 3;
			m_ctlLProgress.SetTopIndex(i1);
		
			m_ctlPDownload.SetRange(0,(int)AppData.m_HexBytes);	//Progress bar.
			iProcessPos = 0;
			m_ctlPDownload.SetPos(iProcessPos);
			iActRow = 0;									// StartRow
			b=0;

			dwNow = GetTickCount();							// Debug
			//for(b=0; b<iBlocks;b++)	
			do
			{
				pcCommand[0] = 0x06;
				pcCommand[1] = AppData.m_AW_PID;
				pcCommand[2] = 'W';                 
				pcCommand[3] = AppData.m_HexArray[iActRow][4];
				pcCommand[4] = AppData.m_HexArray[iActRow][3];
				pcCommand[5] = AppData.m_HexArray[iActRow][2];
				pcCommand[6] = 0x0;								// MSB Adr 0x0
				pcCommand[7] = 0x0;								// LSB ByteCount
				pcCommand[8] = 0x0;								// MSB ByteCount
				pcCommand[9] = 0xFF;
				pcCommand[10] = 0x00;							// CRC
				
				//str.Format(" Startadr: %.2X%.2X%.2X%.2X ",pcCommand[6],pcCommand[5],pcCommand[4],pcCommand[3]);
				//m_ctlLProgress.AddString(str);

				// how many bytes in linear address space
				iDataCount = 0;
				br = 0;
				do
				{
					for(i1=0; i1<AppData.m_HexArray[iActRow][1]; i1++)	
					{
						(pcPacket[iDataCount] = AppData.m_HexArray[iActRow][i1+5]);
						iDataCount++;
					}

					lProgAddr = (unsigned long)(AppData.m_HexArray[b][2]*65536+
												AppData.m_HexArray[b][3]*256+
												AppData.m_HexArray[b][4]+
												AppData.m_HexArray[b][1]);

					lProgAddrN =(unsigned long)(AppData.m_HexArray[b+1][2]*65536+
												AppData.m_HexArray[b+1][3]*256+
												AppData.m_HexArray[b+1][4]);

					b++;
					br++;
					iActRow++;

					
				}
				while(br<AppData.m_BlockSize && (lProgAddr == lProgAddrN));

				// math for writing 8 byte frames to flash, 0xff also
				iFrameblocks = iDataCount/8;		 
				iFrameRest   = iDataCount%8;
				if(iFrameRest != 0)
					iFrameblocks++;

				iFrameRest = iFrameblocks * 8;
				//pcCommand[7] = (unsigned char)iFrameRest;		// bytes to send in this frame


				pcCommand[7] = (unsigned char)iDataCount;		// bytes to send in this frame
				pcCommand[10] = CRC_Enhanced(pcCommand);		// calculate CRC

				str.Format(" FrameLen: %d  CRC: %.2X ",pcCommand[7],pcCommand[10]);
				//m_ctlLProgress.AddString(str);

				switch (AppData.m_PortCom)
				{
					case 1: 
							bLocalCmd = USB_Send_LIN(11, pcCommand);				
						break;
					default:
							AfxMessageBox("No Communication Port");
							bLocalCmd = FALSE;
						break;
				}

				if(!bLocalCmd)
				{
					str1.Format("   Could not send Write Command \n Download aborted.");
					AfxMessageBox(str1);

					str = "   Error in Write Command Sequence !"; // + AppData.strUSB_Message;
					ShowErrors(str);
					iErr=25;
					m_ctlPDownload.SetPos(0);
					return FALSE;
				}

				else
				{
					
				

					iFrameblocks = iDataCount/8;		 
					iFrameRest   = iDataCount%8;
					iArrayData	 = 1;
					iPacket		 = 0;

					//str.Format(" iFrameblocks: %d  iFrameRest: %d ",iFrameblocks,iFrameRest);
					//m_ctlLProgress.AddString(str);

	

					pcData[0] = 0x06;			// key for LIN frame (uses Dongle to detect)


					for(i3=0;i3<iFrameblocks;i3++)
					{
						pcData[iArrayData] = AppData.m_DW_PID;	
						iArrayData++;

						//iCSArray = iArrayData;

						for(i1=0;i1<8;i1++)
						{
							pcData[iArrayData] = pcPacket[iPacket];	// copy data from big frame in send frame	
							
							//iCalCSSend +=	(unsigned int)pcPacket[iPacket]; 

							iArrayData++;
							iPacket++;		
						}

						
						pcData[iArrayData] = CRC_En_Var(pcData,(iArrayData-9));
						//str.Format(" iFrameblocks: %d",(iArrayData-9));
						//m_ctlLProgress.AddString(str);
						iArrayData++;
					}

					
					if(iFrameRest != 0)
					{

						pcData[iArrayData] = AppData.m_DW_PID;	
						iArrayData++;

						for(i3=0;i3<iFrameRest;i3++)
						{
							pcData[iArrayData] = pcPacket[iPacket];	// copy data from big frame in send frame	
							
							iArrayData++;
							iPacket++;
							
						}
						

						iFrameRest = 8-iFrameRest;

						for(i3=0;i3<iFrameRest;i3++)
						{
							pcData[iArrayData] = 0xFF;				// fill up with 0xFF	
							iArrayData++;


						}
						//str.Format(" 2a: FrameRest: %d iArrayData: %d iPacket: %d",iFrameRest, iArrayData, iPacket);
						//m_ctlLProgress.AddString(str);

				
						//str.Format(" 4: FrameRest: %d iArrayData: %d iPacket: %d",iFrameRest, iArrayData, iPacket);
						//m_ctlLProgress.AddString(str);

						pcData[iArrayData] = CRC_En_Var(pcData,(iArrayData-9));
						iArrayData++;
					}

					//str.Format(" calc CRC : %.4X ",iCalCSSend);
					//m_ctlLProgress.AddString(str);

					//str.Format("Array: %.2X%.2X%.2X%.2X%.2X%.2X%.2X%.2X",
					//	pcData[2],pcData[3],pcData[4],pcData[5],pcData[6],pcData[7],pcData[8],pcData[9]);
					//m_ctlLProgress.AddString(str);


					dwToSend = (DWORD)iArrayData;

					iProcessStep = iPacket;					// only data from file, no control
					iProcessPos += iProcessStep;
					m_ctlPDownload.SetPos(iProcessPos);

					switch (AppData.m_PortCom)
					{
						case 1: 
								bLocalCmd = USB_Send_LIN(dwToSend, pcData);				
							break;
						default:
								AfxMessageBox("No Communication Port");
								bLocalCmd = FALSE;
							break;
					}

/*					USB_Read_Status(pcStatus);

					//	str.Format("Read Status: ");

					CRC = AppData.m_SR_PID;						// PID not in frame, but needed for Enhanced CS

					for(int i=0;i<8;i++)
					{
						CRC += pcStatus[i];
						if(CRC > 255)
							CRC -= 255;
						str1.Format("%.2X ",pcStatus[i]);
						str += str1;
					}

					iCRC = (BYTE)CRC;							// should be value of CRC-Field

					iCRCs = iCRC + pcStatus[8];					// should be 0xFF
*/
					//m_ctlLProgress.AddString(str);
					
					//str.Format(" Get-CRC:%.2X  CRC= %.2X  iCRCs = %.2X",pcStatus[8],CRC,iCRCs);
					//m_ctlLProgress.AddString(str);

					//str.Format("              %.2X%.2X%.2X%.2X",pcStatus[7],pcStatus[6],pcStatus[5],pcStatus[4]);
					//m_ctlLProgress.AddString(str);




					if(!bLocalCmd)
					{

						str = "   Communication-Error in Write Sequence !"; // + AppData.strUSB_Message;
						ShowErrors(str);
						iErr=25;
						m_ctlPDownload.SetPos(0);
						return FALSE;
					}

					else
					{
												
						iErr=1;
						bNoError = TRUE;

						CRC = Check_Status_Byte(pcStatus[2], 0x02);
				
						if(CRC == 1)
						{
							if((i1 = m_ctlLProgress.AddString("Error during Write"))>3)	
							i1 -= 3;
							m_ctlLProgress.SetTopIndex(i1);
						}

						if(CRC == 255)
						{
							if((i1 = m_ctlLProgress.AddString("Error in Frame"))>3)	
							i1 -= 3;
							m_ctlLProgress.SetTopIndex(i1);
						}
					}
				}

				str.Format(" Zeilen: %d ",iActRow);
				//m_ctlLProgress.AddString(str);

	
			}
			while(iActRow<AppData.m_HexRows);



			dwEnd = GetTickCount();
			dSec = (double)(dwEnd-dwNow);//1000;

			m_ctlPDownload.SetPos(0);

			str1.Format("     Time to Write: %.3f s",(dSec/1000));
			//m_ctlLProgress.AddString(str1);
			m_ctlLProgress.AddString("   Download complete");
		}

/*		if(AppData.m_verify !=1)			// no verify selected
		{
			if((i1 = m_ctlLProgress.AddString("   Click Run to run program."))>3)	
				i1 -= 3;
			m_ctlLProgress.SetTopIndex(i1);
			m_ctlPDownload.SetPos(0);
			return bNoError;
		}
*/
		if(iErr<10)
		{
			lPktNo = 1;
			str1.Format("%s%d%s","   Verifying ... ",AppData.m_HexBytes," bytes");
			if((i1 = m_ctlLProgress.AddString(str1))>3)	i1 -= 3;
			m_ctlLProgress.SetTopIndex(i1);

			m_ctlPDownload.SetRange(0,(int)AppData.m_HexBytes);	//Progress bar.
			iProcessPos = 0;
			m_ctlPDownload.SetPos(iProcessPos);

			iActRow = 0;									// StartRow
			b=0;

			dwNow = GetTickCount();							// Debug

			// get highest page
				i3 = 0;
				for(i1=0; i1<188;i1++)
				{
					if(AppData.m_PageArray[i1] != 0)
						i3 = i1;
				}
				i3++;

				//str1.Format("Highest Page: %d",(i3-1));
				//m_ctlLProgress.AddString(str1);


				//for(i1=0; i1<184; i1++)
				//for(i1=0; i1<5; )
				i1=0;
				i2=0;
				do
				{
					if(AppData.m_PageArray[i1] != 0)			// only if marked
					{		
						lProgAddr = 0x80000 + 512 * (unsigned long)i1;	// calculate page start address	
						
						pcCommand[0] = 0x06;
						pcCommand[1] = AppData.m_AW_PID;
						pcCommand[2] = 'V';                  
						pcCommand[3] = (unsigned char)(lProgAddr%256);
						pcCommand[4] = (unsigned char)((lProgAddr>>8) %256);                 
						pcCommand[5] = (unsigned char)((lProgAddr>>16)%256); 
						pcCommand[6] = (unsigned char)((lProgAddr>>24)%256);
						pcCommand[7] = 0x0;
						pcCommand[8] = 0x02;	
						pcCommand[9] = 0xFF;
						pcCommand[10] = CRC_Enhanced(pcCommand);// calculate CRC

						//str.Format("Start: %8X",lProgAddr);
						//m_ctlLProgress.AddString(str);


						uiPageCRC = GetCRC(i1);

						i1++;


						iProcessPos += iProcessStep;
						m_ctlPDownload.SetPos(iProcessPos);

						switch (AppData.m_PortCom)
						{
							case 1: 
									bLocalCmd = USB_Send_LIN(11, pcCommand);
									//bLocalCmd = TRUE;
								break;
							default:
								AfxMessageBox("No Communication Port");
								bLocalCmd = FALSE;	
								break;
						}

						if(!bLocalCmd)
						{
							str = "   Error in Verify Sequence !"; // + AppData.strUSB_Message;
							ShowErrors(str);
							iErr=25;
							m_ctlPDownload.SetPos(0);
							return FALSE;
						}
						else
						{
							iErr=1;
							
							uiGetCRC = GetLinCRC();

							usTempStatus = AppData.m_usLINStatus && 0x0B;

							if(usTempStatus != 0x0B)
							{
						
								if(uiPageCRC != uiGetCRC)
								{
									str.Format("CRC-Error in Page: %d Get: %.8X  Need: %.8X   Difference: %d",(i1-1),uiGetCRC,uiPageCRC,(uiGetCRC-uiPageCRC));
									m_ctlLProgress.AddString(str);
								}
							}
							else
							{

								if((i1 = m_ctlLProgress.AddString("   Check setup and try downloading again."))>3)
									i1 -= 3;
								m_ctlLProgress.SetTopIndex(i1);
							}

							CRC = Check_Status_Byte(usTempStatus, 0x01);
				
							if(CRC == 1)
							{
								if((i1 = m_ctlLProgress.AddString("Error during Verify"))>3)	
									i1 -= 3;
								m_ctlLProgress.SetTopIndex(i1);
							}

							if(CRC == 255)
							{
								if((i1 = m_ctlLProgress.AddString("Error in Frame"))>3)	
									i1 -= 3;
								m_ctlLProgress.SetTopIndex(i1);
							}

							if(CRC == 0)
							{
								if(uiPageCRC != uiGetCRC)
								{
									str.Format("CRC-Error in Page: %d Get: %.8X  Need: %.8X   Difference: %d",(i1-1),uiGetCRC,uiPageCRC,(uiGetCRC-uiPageCRC));
									if((i1 = m_ctlLProgress.AddString(str))>3)	
										i1 -= 3;
									m_ctlLProgress.SetTopIndex(i1);
								}
							}



							

							
							//bNoError = TRUE;
						}
						//i2++;

					}
					else
					{
						i1++;
						//i2++;
						//m_ctlLProgress.AddString("No Page");
					}

				}
				while(i1<(unsigned int)i3);
	

			dwEnd = GetTickCount();
			dSec = (double)(dwEnd-dwNow);
			str1.Format("     Time to Verify: %.3f s",(dSec/1000));
			//m_ctlLProgress.AddString(str1);
		}
		
		if(iErr<10)
		{
			//m_ctlLProgress.AddString("   Verify Complete.");
			//if((i1 = m_ctlLProgress.AddString("   Click Run to run program."))>3)
			if((i1 = m_ctlLProgress.AddString("   Verify Complete, writing Checksum."))>3)
				i1 -= 3;
			m_ctlLProgress.SetTopIndex(i1);

			ulPage0CRC = GeneratePageCS();			// 

			pcCommand[0] = 0x06;
			pcCommand[1] = AppData.m_AW_PID;
			pcCommand[2] = 'W';                 
			pcCommand[3] = 0x14;
			pcCommand[4] = 0x00;
			pcCommand[5] = 0x08;
			pcCommand[6] = 0x00;							// MSB Adr 0x0
			pcCommand[7] = 0x08;							// LSB ByteCount
			pcCommand[8] = 0x0;								// MSB ByteCount
			pcCommand[9] = 0xFF;
			pcCommand[10] = CRC_Enhanced(pcCommand);		// calculate CRC

			switch (AppData.m_PortCom)
			{
				case 1: 
						bLocalCmd = USB_Send_LIN(11, pcCommand);
						//bLocalCmd = TRUE;
						break;
				default:
						AfxMessageBox("No Communication Port");
						bLocalCmd = FALSE;	
						break;
			}

			if(!bLocalCmd)
			{
				str1.Format("   Could not send Write Command \n Download aborted.");
				AfxMessageBox(str1);

				str = "   Error in Writing Checksum Sequence !"; // + AppData.strUSB_Message;
				ShowErrors(str);
				iErr=25;
				m_ctlPDownload.SetPos(0);
				return FALSE;
			}
			else
			{
				pcCommand[0] = 0x06;
				pcCommand[1] = AppData.m_DW_PID;
				pcCommand[2] = (unsigned char)(ulPage0CRC%256);                 
				pcCommand[3] = (unsigned char)((ulPage0CRC>>8) %256);
				pcCommand[4] = (unsigned char)((ulPage0CRC>>16)%256);
				pcCommand[5] = (unsigned char)((ulPage0CRC>>24)%256);
				pcCommand[6] = 0xFF;							// Fill
				pcCommand[7] = 0xFF;							// Fill
				pcCommand[8] = 0xFF;							// Fill
				pcCommand[9] = 0xFF;							// Fill
				pcCommand[10] = CRC_Enhanced(pcCommand);		// calculate CRC

				switch (AppData.m_PortCom)
				{
					case 1: 
							bLocalCmd = USB_Send_LIN(11, pcCommand);
							//bLocalCmd = TRUE;
							break;
					default:
							AfxMessageBox("No Communication Port");
							bLocalCmd = FALSE;	
							break;
				}

				if(!bLocalCmd)
				{
					str1.Format("   Could not write CRC \n Download aborted.");
					AfxMessageBox(str1);

					str = "   Error in Writing Checksum Sequence !"; // + AppData.strUSB_Message;
					ShowErrors(str);
					iErr=25;
					m_ctlPDownload.SetPos(0);
					return FALSE;
				}
				else
				{
					//lProgAddr = 0x80000 + 512 * (unsigned long)i1;	// calculate page start address	
						
					pcCommand[0] = 0x06;
					pcCommand[1] = AppData.m_AW_PID;
					pcCommand[2] = 'V';                  
					pcCommand[3] = 0x00;
					pcCommand[4] = 0x00;                 
					pcCommand[5] = 0x08; 
					pcCommand[6] = 0x00;
					pcCommand[7] = 0x00;
					pcCommand[8] = 0x02;	
					pcCommand[9] = 0xFF;
					pcCommand[10] = CRC_Enhanced(pcCommand);// calculate CRC

					
					uiPageCRC = GetCRC(0);

					//str.Format("CRC Page0: %8X",uiPageCRC);
					//m_ctlLProgress.AddString(str);

					switch (AppData.m_PortCom)
					{
						case 1: 
								bLocalCmd = USB_Send_LIN(11, pcCommand);
								//bLocalCmd = TRUE;
								break;
						default:
								AfxMessageBox("No Communication Port");
								bLocalCmd = FALSE;	
								break;
					}

					if(!bLocalCmd)
					{
						str1.Format("   Could not verify Page 0");
						AfxMessageBox(str1);

						str = "   Error in Writing Checksum Sequence !"; // + AppData.strUSB_Message;
						ShowErrors(str);
						iErr=25;
						m_ctlPDownload.SetPos(0);
						return FALSE;
					}
					else
					{

						uiGetCRC = GetLinCRC();

						usTempStatus = AppData.m_usLINStatus && 0x0B;

						if(usTempStatus != 0x0B)
						{
							
							if(uiPageCRC != uiGetCRC)
							{
								str.Format("CRC-Error in Page: %d Get: %.8X  Need: %.8X   Difference: %d",(0),uiGetCRC,uiPageCRC,(uiGetCRC-uiPageCRC));
								m_ctlLProgress.AddString(str);
								bNoError = FALSE;
							}
							else
							{

								bNoError = TRUE;

							}
						}
						else
						{

							if((i1 = m_ctlLProgress.AddString("   Check setup and try downloading again."))>3)
								i1 -= 3;
							m_ctlLProgress.SetTopIndex(i1);
							bNoError = FALSE;
						}

						CRC = Check_Status_Byte(usTempStatus, 0x01);
					
						if(CRC == 1)
						{
							if((i1 = m_ctlLProgress.AddString("Error during Verify"))>3)	
								i1 -= 3;
							m_ctlLProgress.SetTopIndex(i1);
							bNoError = FALSE;

						}

						if(CRC == 255)
						{
							if((i1 = m_ctlLProgress.AddString("Error in Frame"))>3)	
								i1 -= 3;
							m_ctlLProgress.SetTopIndex(i1);
							bNoError = FALSE;

						}

						if(CRC == 0)
						{
							if(uiPageCRC != uiGetCRC)
							{
								str.Format("CRC-Error in Page: %d Get: %.8X  Need: %.8X   Difference: %d",(i1-1),uiGetCRC,uiPageCRC,(uiGetCRC-uiPageCRC));
								if((i1 = m_ctlLProgress.AddString(str))>3)	
									i1 -= 3;
								m_ctlLProgress.SetTopIndex(i1);
								bNoError = FALSE;
							}
							else
								bNoError = TRUE;
						}

						if(bNoError)
						{
							if((i1 = m_ctlLProgress.AddString("   Writing Checksum ok"))>3)
								i1 -= 3;
							m_ctlLProgress.SetTopIndex(i1);
						}
					}

				}
			}
				


			//bNoError = TRUE;
		}
		else
		{
			//m_ctlLProgress.AddString("Verify error.");
			if((i1 = m_ctlLProgress.AddString("   Check setup and try downloading again."))>3)
				i1 -= 3;
			m_ctlLProgress.SetTopIndex(i1);
			bNoError = FALSE;
		}
		
	}
	m_ctlPDownload.SetPos(0);


	GetDlgItem(IDC_START)->EnableWindow(TRUE);
	GetDlgItem(IDC_RUN)->EnableWindow(TRUE);
	GetDlgItem(IDC_B_CONFIG)->EnableWindow(TRUE);

	return bNoError;
				
//download ende				
	
}

BYTE CARMSWDDlg::Check_Status_Byte(unsigned char usIn, unsigned char usTest) 
{
	
	unsigned char usDummy;

	usDummy = usIn && 0x0B;					// E,W and V set ?
	if(usDummy == 0x0B)
	{
		MessageBox("unknown Frame");
		return 255;
	}

	usDummy = usIn && usTest;
	if(usDummy != usIn)
	{
		MessageBox("Command not sucessful");
		return 1;
	}
	else
		return 0;
}

BOOL CARMSWDDlg::DoFlash_I2C() 
{
	CString			str, str1, dummy;

	DWORD			dwEnd,dwNow;
	int				iProcessPos, iProcessStep;
	double			dSec;
	
	DWORD			dwToSend;
	unsigned int	i1,iXsum;
	unsigned int	b,br, iDataCount, iActRow;
	int				iSize;
	int				iErr = 0;
	const unsigned short MAX_MESSAGE = 100;
	unsigned char	pcPacket[256];

	unsigned char	pcMassErase[10] = {0x07,0x0E,0x06,0x45,0x00,0x00,0x00,0x00,0x00,0xB5};

//	char			pcHexTxt[520] ;
	unsigned long	lProgAddr,lProgAddrN;
//	unsigned int	iDataLen;
	long			lPktNo = 1;
	unsigned char	ucXsum;

	BOOL			bNoError = FALSE;		// ErrorFlag for single action (MassErase, Write, Verify)
	
	BOOL			bLocalCmd = FALSE;
	BOOL			bHEXInputOK = FALSE;


	CFileStatus		status;

	if(CFile::GetStatus(AppData.strDFile,status))	
		iSize = status.m_size*16/45;


	ImportHexData();

	
	if(AppData.m_HexBytes != 0)
	{
		
		if(AppData.m_masserase==1)					
		{
			str1.Format("Mass Erasing ...");
			if((i1 = m_ctlLProgress.AddString(str1))>3)	
				i1 -= 3;
			m_ctlLProgress.SetTopIndex(i1);
			UpdateWindow();
			
			switch (AppData.m_PortCom)
			{
				case 1: dwNow = GetTickCount();
						bLocalCmd = USB_Send_Erase(10, pcMassErase);
						if(!bLocalCmd)
						{	
							//str = "   Error in Data Sequence !";	// + AppData.strUSB_Message;
							//ShowErrors(str);
							str1.Format("   Error from MassErase : %X",AppData.m_Answer);
							m_ctlLProgress.AddString(str1);
							break;
						}

						EraseBar();
						
						bLocalCmd = USB_Read_Erase();
						dwEnd = GetTickCount();
					break;
//				case 2:	bLocalCmd = RS232_Send_Frame(10, pcMassErase);
//					break;
				default:
					AfxMessageBox("No Communication Port");
					bLocalCmd = FALSE;	
					break;
			}

			dSec = (double)(dwEnd-dwNow);//1000;
			str1.Format("   Time to Erase: %.3f s",(dSec/1000));
			//m_ctlLProgress.AddString(str1);

			if(!bLocalCmd)
			{
				str1.Format("   Error from MassErase : %X",AppData.m_Answer);
				m_ctlLProgress.AddString(str1);
				m_ctlPDownload.SetPos(0);
				return FALSE;
			}
			else
			{
				//str = "Flash ACK";
				//m_ctlLProgress.AddString(str);
				iErr=1;
				bNoError = TRUE;

			}
			//USB send end

		}

		m_ctlPDownload.SetPos(0);

		if((AppData.m_program != 1) && (AppData.m_masserase == 1) && (AppData.m_verify != 1))	// only Mass Erase selected
		{
			m_ctlLProgress.AddString("Mass Erasing ok");
			return bNoError;
		}

	
		//Processbar only in programm and verify
		m_ctlPDownload.SetStep(1);
		m_ctlPDownload.SetPos(1);


		if(AppData.m_program==1)					// Program
		{
			
			if(AppData.m_EndAddress > 0xf7ff)
			{
				AfxMessageBox("Last address in file exceeds addressrange \n Download aborted.");
				//AfxMessageBox(str1);
				//bNoError = FALSE;
				return FALSE;
			}

			
			m_ctlLProgress.AddString("Programm...");

			lPktNo = 1;
			
			if(AppData.m_masserase!=1)				// only erase if no mass erase was done
			{
				
				str1.Format("   Erasing %d pages of 512 bytes each.",AppData.m_ErasePages);

				if((i1 = m_ctlLProgress.AddString(str1))>3)	i1 -= 3;
				m_ctlLProgress.SetTopIndex(i1);

				m_ctlPDownload.SetRange(0,(int)AppData.m_ErasePages);	//Progress bar.
				iProcessStep = 1;
				iProcessPos = 0;
				m_ctlPDownload.SetPos(iProcessPos);
		
				dwNow = GetTickCount();								// Debug

				for(i1=0; i1<AppData.m_ErasePages; i1++)
				{	
					lProgAddr = i1*512;
					pcPacket[0] = 0x07;								//Erase                 
					pcPacket[1] = 0x0E;                 
					pcPacket[2] = 0x06;
					pcPacket[3] = 'E';                 
					pcPacket[4] = (unsigned char)((lProgAddr>>24)%256);
					pcPacket[5] = (unsigned char)((lProgAddr>>16)%256); 
					pcPacket[6] = (unsigned char)((lProgAddr>>8) %256);
					pcPacket[7] = (unsigned char)(lProgAddr%256);
					pcPacket[8] = 1;								// all.	
					pcPacket[9] = 0-(pcPacket[2]+pcPacket[3]+pcPacket[4]+
									 pcPacket[5]+pcPacket[6]+pcPacket[7]+pcPacket[8]);


					iProcessPos += iProcessStep;
					m_ctlPDownload.SetPos(iProcessPos);

					switch (AppData.m_PortCom)
					{
						case 1: 
								bLocalCmd = USB_Send_Frame(10, pcPacket);
							break;
//						case 2:	bLocalCmd = RS232_Send_Frame(10, pcPacket);
//							break;
						default:
							AfxMessageBox("No Communication Port");
							bLocalCmd = FALSE;	
							break;
					}

					if(!bLocalCmd)
					{
						str = "   Error in Erase Sequence !"; // + AppData.strUSB_Message;
						ShowErrors(str);
						iErr=25;
						m_ctlPDownload.SetPos(0);
						return FALSE;
					}
					else
					{
						iErr=1;
						//bNoError = TRUE;
					}
					//USB send end

					
				}

				dwEnd = GetTickCount();
				dSec = (double)(dwEnd-dwNow);//1000;
				str1.Format("     Time to Erase: %.3f s",(dSec/1000));
				//m_ctlLProgress.AddString(str1);
			}	

		}


		if(AppData.m_program==1 && iErr<10)
		{

			str1.Format("%s%d%s","   Programming ... ",AppData.m_HexBytes," bytes");

			if((i1 = m_ctlLProgress.AddString(str1))>3)	i1 -= 3;
			m_ctlLProgress.SetTopIndex(i1);
		
			m_ctlPDownload.SetRange(0,(int)AppData.m_HexBytes);	//Progress bar.
			iProcessPos = 0;
			m_ctlPDownload.SetPos(iProcessPos);
			iActRow = 0;									// StartRow
			b=0;

			dwNow = GetTickCount();							// Debug
			//for(b=0; b<iBlocks;b++)	
			do
			{
				iXsum = 0;
				pcPacket[0] = 0x07;                 
				pcPacket[1] = 0x0e;                 

				pcPacket[3] = 'W';                 
				pcPacket[4] = 0x0;
				pcPacket[5] = AppData.m_HexArray[iActRow][2];  
				pcPacket[6] = AppData.m_HexArray[iActRow][3];
				pcPacket[7] = AppData.m_HexArray[iActRow][4];
	
				iDataCount = 8;
				br = 0;
				do
				{
					for(i1=0; i1<AppData.m_HexArray[iActRow][1]; i1++)	
					{
						iXsum += (pcPacket[iDataCount] = AppData.m_HexArray[iActRow][i1+5]);
						iDataCount++;
					}

					lProgAddr = (unsigned long)(AppData.m_HexArray[b][2]*65536+
												AppData.m_HexArray[b][3]*256+
												AppData.m_HexArray[b][4]+
												AppData.m_HexArray[b][1]);

					lProgAddrN =(unsigned long)(AppData.m_HexArray[b+1][2]*65536+
												AppData.m_HexArray[b+1][3]*256+
												AppData.m_HexArray[b+1][4]);

					b++;
					br++;
					iActRow++;

					
				}
				while(br<AppData.m_BlockSize && (lProgAddr == lProgAddrN));
				
				pcPacket[2] = (unsigned char)(iDataCount-3);
				ucXsum = pcPacket[2]+pcPacket[3]+pcPacket[4]+pcPacket[5]+pcPacket[6]+pcPacket[7];
				pcPacket[pcPacket[2]+3] = 0-(ucXsum+(unsigned char)(iXsum%256));

				str.Format("     Datalength: %d",(iDataCount-8));
				//m_ctlLProgress.AddString(str);

				dwToSend = (DWORD)pcPacket[2];
				dwToSend += 4;

				iProcessStep = (int)(iDataCount-8);
				iProcessPos += iProcessStep;
				m_ctlPDownload.SetPos(iProcessPos);

				switch (AppData.m_PortCom)
				{
					case 1: 
							bLocalCmd = USB_Send_Frame(dwToSend, pcPacket);				
						break;
//					case 2:	bLocalCmd = RS232_Send_Frame(dwToSend, pcPacket);
//						break;
					default:
							AfxMessageBox("No Communication Port");
							bLocalCmd = FALSE;
						break;
				}

				if(!bLocalCmd)
				{
					lProgAddr = (unsigned long)(AppData.m_HexArray[b-1][2]*65536+
												AppData.m_HexArray[b-1][3]*256+
												AppData.m_HexArray[b-1][4]);

					lProgAddrN =(unsigned long)(AppData.m_HexArray[b-1][2]*65536+
												AppData.m_HexArray[b-1][3]*256+
												AppData.m_HexArray[b-1][4]+
												AppData.m_HexArray[b-1][1]);

					str1.Format("   Error at 0x%lx - 0x%lx \n Download aborted.",
									lProgAddr,lProgAddrN);
					AfxMessageBox(str1);

					str = "   Error in Write Sequence !"; // + AppData.strUSB_Message;
					ShowErrors(str);
					iErr=25;
					m_ctlPDownload.SetPos(0);
					return FALSE;
				}
				else
				{
					iErr=1;
					bNoError = TRUE;
				}

			}
			while(iActRow<AppData.m_HexRows);



			dwEnd = GetTickCount();
			dSec = (double)(dwEnd-dwNow);//1000;

			m_ctlPDownload.SetPos(0);

			str1.Format("     Time to Write: %.3f s",(dSec/1000));
			//m_ctlLProgress.AddString(str1);
			m_ctlLProgress.AddString("   Download complete");
		}

		if(AppData.m_verify !=1)			// no verify selected
		{
			if((i1 = m_ctlLProgress.AddString("   Click Run to run program."))>3)	
				i1 -= 3;
			m_ctlLProgress.SetTopIndex(i1);
			m_ctlPDownload.SetPos(0);
			return bNoError;
		}

		if(AppData.m_verify==1 && iErr<10)
		{
			lPktNo = 1;
			str1.Format("%s%d%s","   Verifying ... ",AppData.m_HexBytes," bytes");
			if((i1 = m_ctlLProgress.AddString(str1))>3)	i1 -= 3;
			m_ctlLProgress.SetTopIndex(i1);

			m_ctlPDownload.SetRange(0,(int)AppData.m_HexBytes);	//Progress bar.
			iProcessPos = 0;
			m_ctlPDownload.SetPos(iProcessPos);

			iActRow = 0;									// StartRow
			b=0;

			dwNow = GetTickCount();							// Debug
			//for(b=0; b<iBlocks;b++)	
			do
			{
				iXsum = 0;
				pcPacket[0] = 0x07;                 
				pcPacket[1] = 0x0e;                 

				pcPacket[3] = 'V';                 
				pcPacket[4] = 0x0;
				pcPacket[5] = AppData.m_HexArray[iActRow][2];  
				pcPacket[6] = AppData.m_HexArray[iActRow][3];
				pcPacket[7] = AppData.m_HexArray[iActRow][4];
	
				iDataCount = 8;
				br = 0;
				do
				{
					for(i1=0; i1<AppData.m_HexArray[iActRow][1]; i1++)	
					{
						iXsum += (pcPacket[iDataCount] = ((AppData.m_HexArray[iActRow][i1+5]<<3)|
													 (AppData.m_HexArray[iActRow][i1+5]>>5)));
						iDataCount++;
					}

					lProgAddr = (unsigned long)(AppData.m_HexArray[b][2]*65536+
												AppData.m_HexArray[b][3]*256+
												AppData.m_HexArray[b][4]+
												AppData.m_HexArray[b][1]);

					lProgAddrN =(unsigned long)(AppData.m_HexArray[b+1][2]*65536+
												AppData.m_HexArray[b+1][3]*256+
												AppData.m_HexArray[b+1][4]);

					b++;
					br++;
					iActRow++;

					
				}
				while(br<AppData.m_BlockSize && (lProgAddr == lProgAddrN));

				//str.Format("     Adr: %.4X  %.4X",lProgAddr,lProgAddrN);
				//m_ctlLProgress.AddString(str);
				
				pcPacket[2] = (unsigned char)(iDataCount-3);
				ucXsum = pcPacket[2]+pcPacket[3]+pcPacket[4]+pcPacket[5]+pcPacket[6]+pcPacket[7];
				pcPacket[pcPacket[2]+3] = 0-(ucXsum+(unsigned char)(iXsum%256));

				str.Format("Datalength: %d",(iDataCount-8));
				//m_ctlLProgress.AddString(str);

				dwToSend = (DWORD)pcPacket[2];
				dwToSend += 4;

				iProcessStep = (int)(iDataCount-8);
				iProcessPos += iProcessStep;
				m_ctlPDownload.SetPos(iProcessPos);

				switch (AppData.m_PortCom)
				{
					case 1: 
							bLocalCmd = USB_Send_Frame(dwToSend, pcPacket);				
						break;
//					case 2:	bLocalCmd = RS232_Send_Frame(dwToSend, pcPacket);
//						break;
					default:
							AfxMessageBox("No Communication Port");
							bLocalCmd = FALSE;
						break;
				}

				if(!bLocalCmd)
				{
					lProgAddr = (unsigned long)(AppData.m_HexArray[b-1][2]*65536+
												AppData.m_HexArray[b-1][3]*256+
												AppData.m_HexArray[b-1][4]);

					lProgAddrN =(unsigned long)(AppData.m_HexArray[b-1][2]*65536+
												AppData.m_HexArray[b-1][3]*256+
												AppData.m_HexArray[b-1][4]+
												AppData.m_HexArray[b-1][1]);

					str1.Format("   Error at %.4X -  %.4X Verify aborted.",
									lProgAddr,lProgAddrN);
					//AfxMessageBox(str1);
					m_ctlLProgress.AddString(str1);

					str = "   Error in Verify Sequence !"; // + AppData.strUSB_Message;
					ShowErrors(str);
					iErr=25;
					m_ctlPDownload.SetPos(0);
					return FALSE;
				}
				else
				{
					iErr=1;
					bNoError = TRUE;
				}

			}
			while(iActRow<AppData.m_HexRows);

			dwEnd = GetTickCount();
			dSec = (double)(dwEnd-dwNow);
			str1.Format("     Time to Verify: %.3f s",(dSec/1000));
			//m_ctlLProgress.AddString(str1);
		}
		if(iErr<10)
		{
			m_ctlLProgress.AddString("   Verify Complete.");
			if((i1 = m_ctlLProgress.AddString("   Click Run to run program."))>3)	
				i1 -= 3;
			m_ctlLProgress.SetTopIndex(i1);
			bNoError = TRUE;
		}
		else
		{
			//m_ctlLProgress.AddString("Verify error.");
			if((i1 = m_ctlLProgress.AddString("   Check setup and try downloading again."))>3)
				i1 -= 3;
			m_ctlLProgress.SetTopIndex(i1);
			bNoError = FALSE;
		}
		
	}
	m_ctlPDownload.SetPos(0);


	GetDlgItem(IDC_START)->EnableWindow(TRUE);
	GetDlgItem(IDC_RUN)->EnableWindow(TRUE);
	GetDlgItem(IDC_B_CONFIG)->EnableWindow(TRUE);

	return bNoError;
				
//download ende				
	
}

void CARMSWDDlg::EraseBar(void)
{ 
		
	DWORD dwNow, dwEnd;

	int nLower, nUpper;
	m_ctlPDownload.GetRange( nLower, nUpper );
	m_ctlPDownload.SetStep( (nUpper-nLower)/25 );
	m_ctlPDownload.SetPos(1);

	for(int i=0;i<25;i++)
	{
		dwEnd = GetTickCount();
		dwEnd += 200;
		dwNow	= 0;

		while (dwEnd > dwNow)
			dwNow = GetTickCount();
	
		m_ctlPDownload.StepIt();
	}
}

BOOL CARMSWDDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	CString	str1,str2;

	str1 = AppData.m_strEcBrowser;
	str2 = AppData.m_strEcHelpp;
	ShellExecute(m_hWnd,"open",str1,str2+"\\ADC_B.html",NULL,SW_SHOW);	
//	return CDialog::OnHelpInfo(pHelpInfo);
	return	1;
}

void CARMSWDDlg::OnTest() 
{

/*	CString strID = "abcdefghijklmnopqrstuvwxyz1234";

	USB_Read_DongleIdent(1, strID);
	AppData.m_DongleIdent = strID;
	m_ctlLProgress.AddString(AppData.m_DongleIdent);


	strID = "abcdefghijklmnopqrstuvwxyz1234";
	USB_Read_DongleIdent(2,strID);
	AppData.m_UserIdent = strID;
	m_ctlLProgress.AddString(AppData.m_UserIdent);
*/

	ImportHexData();						// Import HEX
	
	//OnReadPage();
//	GeneratePageCS();
//	ClearPageCS();
	FillCRCArray();							// configure Page Array for CRC
	GeneratePageCS();	


//	OnReadPage();
	
}

void CARMSWDDlg::ClearPageCS() 
{
	int i1,i2;
	CString str;

	unsigned long lProgAddr, lAddrEnd;


	for(i1=0;i1<32;i1++)
	{
		lProgAddr = (unsigned long)(AppData.m_HexArray[i1][2]*65536);
		lProgAddr += (unsigned long)(AppData.m_HexArray[i1][3]*256);
		lProgAddr += (unsigned long)(AppData.m_HexArray[i1][4]);

		lAddrEnd  = lProgAddr + (unsigned long)(AppData.m_HexArray[i1][1]);

		//str.Format("Start: %.8X  End: %.8X",lProgAddr, lAddrEnd);
		//m_ctlLProgress.AddString(str);

		if((lProgAddr <= 0x80014) && (0x80014 <= lAddrEnd))
		{
			//m_ctlLProgress.AddString("Korrektur");
			i2 = (int)(0x80014 - lProgAddr);		// get offset to array
			i2 += 5;								// data start at element 5

			str.Format(" old File 0x14: %.2X%.2X%.2X%.2X",	AppData.m_HexArray[i1][i2+3],
														AppData.m_HexArray[i1][i2+2],
														AppData.m_HexArray[i1][i2+1],
														AppData.m_HexArray[i1][i2]);

			m_ctlLProgress.AddString(str);

			AppData.m_HexArray[i1][i2+3] = 0xFF;
			AppData.m_HexArray[i1][i2+2] = 0xFF;
			AppData.m_HexArray[i1][i2+1] = 0xFF;
			AppData.m_HexArray[i1][i2]	 = 0xFF;

			str.Format(" new File 0x14: %.2X%.2X%.2X%.2X",	AppData.m_HexArray[i1][i2+3],
														AppData.m_HexArray[i1][i2+2],
														AppData.m_HexArray[i1][i2+1],
														AppData.m_HexArray[i1][i2]);

		
			m_ctlLProgress.AddString(str);

			i1 = 32;	// abbort
		}
	}


}


unsigned long CARMSWDDlg::GeneratePageCS() 
{
	CString	str,str1;

	unsigned long uiUserCRC,uiDummy,uiDummy1;

	
	str.Format(" From File 0x14: %.2X%.2X%.2X%.2X",	AppData.m_VerifyArray[0][0x17],
											AppData.m_VerifyArray[0][0x16],
											AppData.m_VerifyArray[0][0x15],
											AppData.m_VerifyArray[0][0x14]);

	m_ctlLProgress.AddString(str);


	uiUserCRC = GetCRC(0);

	uiDummy = (unsigned long)AppData.m_VerifyArray[0][0x17] * 256;
	uiDummy += (unsigned long)AppData.m_VerifyArray[0][0x16];

	uiDummy1 = (unsigned long)AppData.m_VerifyArray[0][0x15] * 256;
	uiDummy1 += (unsigned long)AppData.m_VerifyArray[0][0x14];

	str1.Format(" %.8X  %.4X  %4X",uiUserCRC,uiDummy,uiDummy1);
	//m_ctlLProgress.AddString(str1);

	uiUserCRC -= uiDummy;
	uiUserCRC -= uiDummy1;

	str1.Format(" cal.CRC: %8X",uiUserCRC);
	m_ctlLProgress.AddString(str1);

	if(AppData.m_iCRC == 0)
	{

		AppData.m_VerifyArray[0][0x14] = (unsigned char)(uiUserCRC%256);
		AppData.m_VerifyArray[0][0x15] = (unsigned char)((uiUserCRC>>8) %256);                 
		AppData.m_VerifyArray[0][0x16] = (unsigned char)((uiUserCRC>>16)%256); 
		AppData.m_VerifyArray[0][0x17] = (unsigned char)((uiUserCRC>>24)%256);

		str.Format("  Cal. CRC at 0x14: %.2X%.2X%.2X%.2X",	AppData.m_VerifyArray[0][0x17],
												AppData.m_VerifyArray[0][0x16],
												AppData.m_VerifyArray[0][0x15],
												AppData.m_VerifyArray[0][0x14]);

		m_ctlLProgress.AddString(str);

		return(uiUserCRC);
	}

	if(AppData.m_iCRC == 1)
	{
		AppData.m_VerifyArray[0][0x14] = 0x70;
		AppData.m_VerifyArray[0][0x15] = 0x19;                 
		AppData.m_VerifyArray[0][0x16] = 0x01; 
		AppData.m_VerifyArray[0][0x17] = 0x27;

		str.Format("  Dev. CRC at 0x14: %.2X%.2X%.2X%.2X",	AppData.m_VerifyArray[0][0x17],
												AppData.m_VerifyArray[0][0x16],
												AppData.m_VerifyArray[0][0x15],
												AppData.m_VerifyArray[0][0x14]);

		m_ctlLProgress.AddString(str);

		return(0x27011970);
	}

	if(AppData.m_iCRC == 2)
	{

		str.Format("  Imp. CRC at 0x14: %.2X%.2X%.2X%.2X",	AppData.m_VerifyArray[0][0x17],
												AppData.m_VerifyArray[0][0x16],
												AppData.m_VerifyArray[0][0x15],
												AppData.m_VerifyArray[0][0x14]);

		m_ctlLProgress.AddString(str);

		return(uiUserCRC);
	}


	return(0xFFFFFFFF);					// Never
}



void CARMSWDDlg::OnBSecwriteok()	// PID for SW and step to wait L-Cmd
{
	BYTE ReturnByte[10] = {0x00};
	BYTE SendByte[11] = {0x06,0x3C,0x7F,0x06,0xB1,0x3A,0x00,0x00,0x00,0x30,0xFF};
	CString str,str1;

	SendByte[10] = CRC_Classic(SendByte);

	USB_Send_Frame(11, SendByte);	
	str.Format("PID Secure Write: %.2X %C",AppData.m_Answer, AppData.m_Answer);

	m_ctlLProgress.AddString(str);
}






void CARMSWDDlg::OnBCmdDl()		// Download
{
	BYTE ReturnByte[10] = {0x00};
	BYTE SendByte[11] = {0x06,0x30,0x4C,0xFF,0x42,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF};
	CString str,str1;

	SendByte[1] = AppData.m_SW_PID;

	SendByte[10] = CRC_En_Var(SendByte,10);

	USB_Send_Frame(11, SendByte);	
	str.Format("Download Cmd: %.2X %C",AppData.m_Answer, AppData.m_Answer);

	m_ctlLProgress.AddString(str);
}


void CARMSWDDlg::OnBStatus()	// Read Status
{
	BYTE ReturnByte[10]		= {0x00};
	BYTE SendByte[2]		= {0x06,0x33};
	unsigned short	CRC		= 0;
	CString str,str1;
	BYTE	iCRC = 0;
	BYTE	iCRCs	= 0;

	SendByte[1] = AppData.m_SR_PID;

	USB_Read_Status(ReturnByte);

	str.Format("Read Status: ");

	CRC = (unsigned short)AppData.m_SR_PID;

	for(int i=0;i<8;i++)
	{
		CRC += ReturnByte[i];
		if(CRC > 255)
			CRC -= 255;
		str1.Format("%.2X ",ReturnByte[i]);
		str += str1;
	}

	iCRC	= (BYTE)CRC;
	iCRCs	= ((BYTE)CRC) + ReturnByte[8];
	str1.Format("%.2X ",ReturnByte[8]);
	str += str1;
	
//	str1.Format(" calc. CRC:%.2X added CRC: %.2X",iCRC,iCRCs);
//	str += str1;
	
	m_ctlLProgress.AddString(str);

	if(iCRCs != 0xFF)
	{
		str.Format("CRC Error get: %.2X  need: %.2X",ReturnByte[8], ((BYTE)~CRC));
		m_ctlLProgress.AddString(str);
	}
}

void CARMSWDDlg::OnStartLin() 
{
	BOOL	bIni = FALSE;
	CString str;
	int		i1;

	bIni = OnUsbCheck();

	if(bIni)
	{
		str = "   Connected to LIN Dongle";		

		if((i1 = m_ctlLProgress.AddString(str))>3)	
				i1 -= 3;
		m_ctlLProgress.SetTopIndex(i1);

		AppData.m_Online = TRUE;

		AppData.m_PortCom = 1;

		UpdateSBar();

	}
	else
	{
		str = "   Error in Communication:  " + AppData.str_Message;
		m_ctlLProgress.AddString(str);

		str = "   " + AppData.strUSB_ParserError;
		if((i1 = m_ctlLProgress.AddString(str))>3)	
				i1 -= 3;
		m_ctlLProgress.SetTopIndex(i1);
		//ShowErrors(str);
		SetStartButtons();
	}


}

void CARMSWDDlg::OnLinFlash() 
{
	BOOL bStatus;

	bStatus = DoFlash_LIN();
	
}

void CARMSWDDlg::FillCRCArray() 
{
	CString str;
	
	int i1,i2,i3,iv,iv1, iSetAddr,iBlockEnd;

	unsigned long lProgAddr, lAddrStart, lAddrEnd;

	// Fill the array with 0xFF
	for(i1=0;i1<188;i1++)
	{
		for(i2=0;i2<512;i2++)
			AppData.m_VerifyArray[i1][i2] = 0xFF;
	}


	// copy HEX in Verify
	for(i3=0;i3<188;i3++)
	{
		lAddrStart = 0x80000 + 512 * (unsigned long)i3;	// calculate address for Pagestart


		//lAddrStart = lProgAddr;
		lAddrEnd = lAddrStart + 512;

		str.Format("Page Start: %.4X  Page End: %.4X ",lAddrStart, lAddrEnd);
		//m_ctlLProgress.AddString(str);
		
		
		for(i2=0;i2<(int)AppData.m_HexRows;i2++)
		{
			if(AppData.m_HexArray[i2][0] == 0x01)
			{
				iv =5;

				lProgAddr = (unsigned long)(AppData.m_HexArray[i2][2]*65536);
				lProgAddr += (unsigned long)(AppData.m_HexArray[i2][3]*256);
				lProgAddr += (unsigned long)(AppData.m_HexArray[i2][4]);
						
				if((lAddrStart <= lProgAddr) && (lProgAddr < lAddrEnd)) // Start HEX between Start and End Page 
				{
					iSetAddr  = (int)(AppData.m_HexArray[i2][2]*65536); 
					iSetAddr += (int)(AppData.m_HexArray[i2][3]*256);
					iSetAddr += (int)(AppData.m_HexArray[i2][4]);

					iSetAddr = iSetAddr - (int)lAddrStart;

					iBlockEnd = iSetAddr+(int)(AppData.m_HexArray[i2][1]-1);
										
											
					if(lAddrEnd >= (lAddrStart + (unsigned long)(iBlockEnd-1)))
					{	
						for(iv1=iSetAddr; iv1<=iBlockEnd; iv1++)
						{
							AppData.m_VerifyArray[i3][iv1] = AppData.m_HexArray[i2][iv];
							iv++;
						}
						iv =5;

						str.Format("Start: %.8X  End: %.8X  LEN: %.2X iv1: %d",
								(iSetAddr+lAddrStart),(iBlockEnd+lAddrStart),AppData.m_HexArray[i2][1],iv1);
						//m_ctlLProgress.AddString(str);
						//m_ctlLProgress.AddString("Block ok");
					}
					else
					{
						for(iv1=iSetAddr; iv1<512; iv1++)
						{
							AppData.m_VerifyArray[i3][iv1] = AppData.m_HexArray[i2][iv];
							iv++;
						}

						//str.Format("Start: %.4X  End: %.4X  LEN: %.2X iv1: %d",
						//		(iSetAddr+lAddrStart), (iBlockEnd+lAddrStart),AppData.m_HexArray[i2][1],iv1);
								//lAddrStart, lAddrEnd,AppData.m_HexArray[i2][1]);
						//m_ctlLProgress.AddString(str);

						iBlockEnd -= 512;
						
						for(iv1=0; iv1<=iBlockEnd; iv1++)
						{
							AppData.m_VerifyArray[i3+1][iv1] = AppData.m_HexArray[i2][iv];
							iv++;
						}

						//str.Format("Start: %.4X  End: %.4X  LEN: %.2X iv1: %d",
						//		(iSetAddr+lAddrStart+iv1+1),(iBlockEnd+lAddrStart+512),AppData.m_HexArray[i2][1],iv1+1);
								//lAddrStart, lAddrEnd,AppData.m_HexArray[i2][1]);
						//m_ctlLProgress.AddString(str);
						//m_ctlLProgress.AddString("BlockError");	
					}
				}
									
			}
		}
	}
}


unsigned int CARMSWDDlg::GetCRC(unsigned int uiPage) 
{
	int iBytes;
	CString str, str1;

	unsigned int uiCRC = 0;	
	unsigned int uiCZ;

	for(iBytes=0;iBytes<512;)
	{
		uiCRC += (unsigned int)AppData.m_VerifyArray[uiPage][iBytes];
		//str.Format("Byte_L: %.4X ",AppData.m_VerifyArray[uiPage][iBytes]);
		iBytes++;

		uiCZ = (unsigned int)AppData.m_VerifyArray[uiPage][iBytes];
		iBytes++;

		uiCZ = uiCZ*256;
		//str1.Format("Byte_H: %.4X  Worte: %d",uiCZ,iBytes);
		//str += str1;
		uiCRC += uiCZ;	
		//str1.Format("CRC: %.8X  ",uiCRC);

		
		
		//str += str1;
		//m_ctlLProgress.AddString(str1);
	}

	return uiCRC;
}

unsigned int CARMSWDDlg::GetLinCRC() 
{
	unsigned char	pcStatus[9];
	unsigned int CRCReturn;

	CString str;

	USB_Read_Status(pcStatus);

	//	str.Format("Read Status: ");

	CRCReturn = (unsigned int)(	pcStatus[7]*65536 + 
								pcStatus[6]*65536+
								pcStatus[5]*256+
								pcStatus[4]);


	//str.Format(" LIN CRC:%.8X ",CRCReturn);
	//m_ctlLProgress.AddString(str);

	AppData.m_usLINStatus = pcStatus[2];

	return CRCReturn;
}

void CARMSWDDlg::OnReadPage() 
{
	if((logfile = fopen( "Logfile.txt", "wb+" )) == NULL )
		MessageBox("Logfile open");
	
	unsigned int	i1,i2,i3,i4,uiPageCounter;
	CString			str1, strBreak,str2,str= "";
	unsigned int	uiZAdr,uiSpace;
	unsigned int	uiProgAddr,uiByteLen,uiLastAdr,m_uiPage = 0;
	BOOL			bBreak = FALSE;

	UpdateData(TRUE);

	uiPageCounter = m_uiPage;

	for(i4=0;i4<4;i4++)
	{
		str1.Format("Page: %d",m_uiPage);
		fputs(str1,logfile);
		fputs("\n",logfile);
		fputs("                   00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F" ,logfile);
		fputs("\n",logfile);

		i1=0;
		do 
		{
			fputs("\n",logfile);
			uiZAdr = 0x80000 + (m_uiPage*512)+i1;
			str.Format("RowAdr: %.8X   ",uiZAdr);
			fputs(str,logfile);
			//fputs("\n",logfile);
			str = "";
			for(i2=0;i2<16;i2++)
			{
				str1.Format("%.2X ",AppData.m_VerifyArray[m_uiPage][i1]);
				i1++;				

				str += str1;
			}
			fputs(str,logfile);
			fputs("\n",logfile);

			for(i2=0;i2<AppData.m_HexRows;i2++)
			{
				if(AppData.m_HexArray[i2][0] == 0x01)
				{
					uiProgAddr = (unsigned int)(AppData.m_HexArray[i2][2]*65536);
					uiProgAddr += (unsigned int)(AppData.m_HexArray[i2][3]*256);
					uiProgAddr += (unsigned int)(AppData.m_HexArray[i2][4]);

					//str1.Format("%.8X ",uiProgAddr);	
					//m_ctlLProgress.AddString(str1);

					if((uiZAdr <= uiProgAddr) && ((uiZAdr+16) > uiProgAddr))	// Start in actual row
					{
						uiByteLen = (unsigned int)(AppData.m_HexArray[i2][1]);
						//str.Format(" i2: %d  Bytes: %d Start: %.8X   ZAdr: %.8X",i2, uiByteLen,uiProgAddr,uiZAdr);
						//m_ctlLProgress.AddString(str);


						if((uiProgAddr+uiByteLen) == (uiZAdr+16))
						{
							if(uiProgAddr == uiZAdr)
							{
								
								str = "Full               ";
								for(i3=5;i3<(uiByteLen+5);i3++)
								{
									str1.Format("%.2X ",AppData.m_HexArray[i2][i3]);	
									//m_ctlLProgress.AddString(str1);
									str += str1;
								}

								fputs(str,logfile);
								fputs("\n",logfile);

							}
							else
							{
								str = "Fill               ";
								uiSpace = uiProgAddr - uiZAdr;

								for(i3=0;i3<uiSpace;i3++)
									str += "   ";

								for(i3=5;i3<(uiByteLen+5);i3++)
								{
									str1.Format("%.2X ",AppData.m_HexArray[i2][i3]);				
									str += str1;
								}
							}
						}
						else
						{
							
							//uiSpace = uiProgAddr - uiZAdr;

							if((uiProgAddr+uiByteLen) < (uiZAdr+16))	
							{
								str = "Kleiner            ";
								str2 = "";
								for(i3=5;i3<(uiByteLen+5);i3++)
								{
									str1.Format("%.2X ",AppData.m_HexArray[i2][i3]);				
									str += str1;
								}


								fputs(str,logfile);
								//fputs("\n",logfile);

								bBreak = TRUE;
							}

							if((uiProgAddr+uiByteLen) > (uiZAdr+16))	
							{
								
								//fputs("Border",logfile);
								uiSpace =  16 + uiZAdr - uiProgAddr;
								
								//str.Format("ByteLen: %d   Space: %d",uiByteLen,uiSpace);
								//m_ctlLProgress.AddString(str);

								if(uiProgAddr != (uiLastAdr + uiByteLen));
									//fputs("\n",logfile);
			
								
								//fputs("\n",logfile);
		
								str2 = "";
								for(i3=5;i3<(uiSpace+5);i3++)
								{
									str1.Format("%.2X ",AppData.m_HexArray[i2][i3]);				
									str2 += str1;
								}

								if(!bBreak)
								{
									str = "                   ";
									str += str2;
								}
								else
								{	
									str = "Break              ";
									str += strBreak;
									str += str2;
								}

								fputs(str,logfile);
								fputs("\n",logfile);		// Rest schreiben

								
								str2 = "";
								while(i3<(uiByteLen+5))
								{
									str1.Format("%.2X ",AppData.m_HexArray[i2][i3]);				
									str2 += str1;
									i3++;
									
								}
								//MessageBox(str);

								strBreak = str2;
								bBreak = TRUE;

								//fputs(strBreak,logfile);
								//fputs("\n",logfile);		// Rest schreiben
								
						
								

								
								
							}



							

						
						}

					}
				}

				uiLastAdr = uiProgAddr;
			}
		}
		while(i1<512);

		m_uiPage++;

		if(bBreak)
		{

			fputs("Break for next Page",logfile);
			fputs("\n",logfile);		// Rest schreiben
			str = "Break              ";
			str += strBreak;
			fputs(str,logfile);
			fputs("\n",logfile);		// Rest schreiben
		}
	}

	fclose( logfile );
	
	
// DataFlag, Len, Adr_H, Adr_M, Adr_L, 16 * data;	
//	m_HexArray[8000][21];	  // HEX-Data Import
	
}


void CARMSWDDlg::OnBWrongFrame() 
{
	//BYTE ReturnByte[10] = {0x00};
	BYTE SendByte[7] = {0x03,0x2C,0xAA,0xBB,0xEE,0x44,0x22};
	CString str,str1;

	//SendByte[10] = CRC_Classic(SendByte);

	USB_Send_LIN(7, SendByte);	
	str.Format("Wrong Frame: %.2X %C",AppData.m_Answer, AppData.m_Answer);

	m_ctlLProgress.AddString(str);	
}


BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();


	if(AppData.m_CPU == 0)
		m_strAbEdit = "I2CWSD Version 1.1";
	else
		m_strAbEdit = "LINWSD Version 1.1";

	UpdateData(FALSE);

	
	// TODO: Zustzliche Initialisierung hier einfgen
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}
