// Functions for HEX
#include "StdAfx.h"
#include "daten.h"

void ConvertHexLn(char *pcHexLn,unsigned long *addr,unsigned int *len,unsigned char *data)
{
	unsigned int iBytecount;
	unsigned char cCSum=0;			//Checksum.
	unsigned int iRectype;
	unsigned int packetxsum;
	unsigned int i1;
	unsigned long ulTmp;

	*len = 0;
    if(sscanf(pcHexLn+1,"%2x",&iBytecount)==1)	
	{
		cCSum += iBytecount;
		if(sscanf(pcHexLn+3,"%4lx",addr)==1)
		{
			cCSum += (unsigned char)((*addr)/256);
			cCSum += (unsigned char)((*addr)%256);
			if(sscanf(pcHexLn+7,"%2x",&iRectype)==1)	
			{
				cCSum += iRectype;
				for(i1=0; i1<iBytecount; i1++)
				{
					sscanf(pcHexLn+9+i1*2,"%2x",&ulTmp);
					data[i1] = (unsigned char)ulTmp;
					cCSum += data[i1];
				}
				if(sscanf(pcHexLn+9+iBytecount*2,"%2x",&ulTmp)==1)	
				{
					packetxsum = (int)ulTmp;
					cCSum += packetxsum;
					if((cCSum==0) && (iRectype==0))	
						*len = iBytecount;	//Ignore other rectypes.
				}	
			}	
		}	
	}	
}

void ImportHexLn(char *pcHexLn,unsigned long *addr,unsigned char *len,unsigned char *data)
{
	unsigned char iBytecount;
	unsigned char cCSum=0;			//Checksum.
	unsigned int iRectype;
	unsigned int packetxsum;
	unsigned int i1;
	unsigned long ulTmp;
	unsigned long ulAdrOffset = 0;
	CString str;
	

	//*len = 0;
    if(sscanf(pcHexLn+1,"%2x",&iBytecount)==1)	
	{
		cCSum += iBytecount;
		if(sscanf(pcHexLn+3,"%4lx",addr)==1)
		{
			cCSum += (unsigned char)((*addr)/256);
			cCSum += (unsigned char)((*addr)%256);
			*addr += AppData.m_AdrOffset;				// Offset

			if(sscanf(pcHexLn+7,"%2x",&iRectype)==1)	
			{
				cCSum += iRectype;
				if(iRectype==0)
				{
					for(i1=0; i1<iBytecount; i1++)
					{
						sscanf(pcHexLn+9+i1*2,"%2x",&ulTmp);
						data[i1] = (unsigned char)ulTmp;
						cCSum += data[i1];
					}
				}

				if(iRectype==2)
				{
					sscanf(pcHexLn+9,"%4x",&ulTmp);
					ulAdrOffset = ulTmp;
					cCSum += (unsigned char)((ulTmp)/256);
					cCSum += (unsigned char)((ulTmp)%256);

					//str.Format("Input: %6X",ulTmp);
					//AfxMessageBox(str);

				}

			

				if(iRectype==0)
				{
					if(sscanf(pcHexLn+9+iBytecount*2,"%2x",&ulTmp)==1)	
					{
						packetxsum = (int)ulTmp;
						cCSum += packetxsum;

						//if((cCSum==0) && (iRectype==0))
						if(cCSum==0)
						{
							*len = iBytecount;			//Ignore other rectypes.
						}

							
					}
				
				}

				if(iRectype==2)
				{
					if(sscanf(pcHexLn+9+iBytecount*2,"%2x",&ulTmp)==1)	
					{
						packetxsum = (int)ulTmp;
						cCSum += packetxsum;

						if((cCSum==0) && (AppData.m_CPU != 0))	
						{
							AppData.m_AdrOffset = (ulAdrOffset << 4);
							*len = 0;					// no data
							//str.Format("Input: %8X",AppData.m_AdrOffset);
							//AfxMessageBox(str);
						}

					}	
				}

			}		
		}	
	}	

}

