// AppData.h: Schnittstelle fr die Klasse CAppData.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_APPDATA_H__61AAE50B_B3B2_4097_B30C_8CE3BA3F4D4C__INCLUDED_)
#define AFX_APPDATA_H__61AAE50B_B3B2_4097_B30C_8CE3BA3F4D4C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



class CAppData  
{
public:
	void ReadIni();
	void WriteIni();
	CAppData();
	virtual ~CAppData();

// ini File
	CString strAppPath, strIni;

//Browse
	CString	strDFile;
	CString	strProjPath;
	CString	strFilePath; 
	CString	strFileName; 
	CString	strFileExtension;
	CString	strFileTitle;
	BOOL	m_AutoClear;			// Clear content in LogWindow

	int		iMemSize;


// Config
	BOOL	m_masserase;
	BOOL	m_erase;
	BOOL	m_program;
	BOOL	m_verify;
//Help
	CString m_strEcBrowser;
	CString m_strEcHelpp;

// USB
	BOOL	m_USBOpen;				// USB Port opend
	CString	m_strUSBSpeed;			// Speed for USB (I2C)
	CString	strUSB_ParserError;		// Error from FT_Status Parser

// RS232
	BOOL	m_ComOpen;
	CString m_strComPort;			// Port for RS232
	CString m_strComSet;			// Settings for COM
	CString	m_strComSpeed;			// Speed for RS232

	BYTE	m_CPU;					//  702x = 0; 703x = 1; 

// Communication
	BOOL	m_IniFile;				// Control for look and feel
	BOOL	m_Setup;				// Setup ok
	BOOL	m_Online;				// Communication online
	BYTE	m_PortCom;				// Sort of Port (0 = none, 1 = USB, 2 = COM)
	BYTE	m_Answer;				// Answer from Com Channel
	CString	str_Message;			// Message from Communication channel
	CString m_strCommuSpeed;		// Speed for Communication

// HEX-Import
					// DataFlag, Len, Adr_H, Adr_M, Adr_L, 16 * data;	
	unsigned char	m_HexArray[8000][21];	  // HEX-Data Import
	unsigned char	m_VerifyArray[188][512];  // Array to generate CRC
	unsigned char	m_PageArray[188];		  // PageFlag to Erase
	unsigned int	m_HexBytes;		// number of imported databytes (data only)	
	unsigned int	m_HexRows;		// number of imported rows
	unsigned long	m_EndAddress;	// lagrest address	
	unsigned int	m_ErasePages;	// Pages to erase
	unsigned int	m_BlockSize;	// how many blocks a 16 data bytes 	
	BOOL			m_bFileOpen;	// Flag for DebugFile
	unsigned long	m_AdrOffset;	// Offset for Adress (get by the 02 record type in HEX-File)

// LIN

	BYTE	m_SW_PID;				// PID for Secure Write
	BYTE	m_AW_PID;				// PID for Address Write
	BYTE	m_DW_PID;				// PID for Data Write
	BYTE	m_SR_PID;				// PID for Status Read
	BYTE	m_LIN_CPU;				// Ident for LIN CPU      (7030 = 0, 7032 = 1)
	unsigned char m_usLINStatus;	// StatusByte from LIN Status Frame	
	int		m_iCRC;					// User or Development CRC

// Dongle
	CString	m_DongleIdent;			// Identstring from Dongle
	CString	m_UserIdent;			// Identstring from Dongle
	
};

#endif // !defined(AFX_APPDATA_H__61AAE50B_B3B2_4097_B30C_8CE3BA3F4D4C__INCLUDED_)
