#ifndef USB_H_
#define USB_H_

void ParseError(CString &str,FT_STATUS inStatus);
BOOL I2C_Init(void);
BOOL LIN_Init(void);
BOOL OnUsbCheck(void);
BOOL USB_Close(void);
BOOL USB_Setup(void);
BOOL USB_Run_CMD(void);
BOOL USB_Send_Frame(DWORD dwToWrite, BYTE* TxData);
BOOL USB_Send_LIN(DWORD dwToWrite, BYTE* TxData);
BOOL USB_Send_Erase(DWORD dwToWrite, BYTE* TxData);
BOOL USB_Read_Erase(void);
BOOL Set_USB_Speed(BYTE isLatency);
void ConvertHexLn(char *pcHexLn,unsigned long *addr,unsigned int *len,unsigned char *data);
BYTE CRC_Classic(BYTE *pAFrame);
BYTE CRC_Enhanced(BYTE *pAFrame);
BYTE CRC_En_Var(unsigned char *pData,int iPointer);
BOOL USB_Read_Status(BYTE* RxData);
BOOL USB_Read_DongleIdent(BYTE Ident, CString &strID);


#endif